/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2002 from the
 * contents of URPM.xs. Do not edit this file, edit URPM.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "URPM.xs"
/* Copyright (c) 2002, 2003, 2004, 2005 MandrakeSoft SA
 * Copyright (c) 2005, 2006, 2007, 2008 Mandriva SA
 *
 * All rights reserved.
 * This program is free software; you can redistribute it and/or
 * modify it under the same terms as Perl itself.
 *
 * $Id: URPM.xs 273048 2011-07-04 15:18:02Z peroyvind $
 * 
 */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <sys/utsname.h>
#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>
#include <zlib.h>
#include <libintl.h>

#undef Fflush
#undef Mkdir
#undef Stat
#undef Fstat

#ifdef RPM_ORG
static inline void *_free(const void * p) { 
  if (p != NULL) free((void *)p); 
  return NULL;
}
typedef struct rpmSpec_s * Spec;
#else
#include <rpm/rpm46compat.h>
#endif

#include <rpm/rpmio.h>
#include <rpm/rpmdb.h>
#include <rpm/rpmts.h>
#include <rpm/rpmte.h>
#include <rpm/rpmps.h>
#include <rpm/rpmpgp.h>
#include <rpm/rpmcli.h>
#include <rpm/rpmbuild.h>
#include <rpm/rpmlog.h>

struct s_Package {
  char *info;
  int  filesize;
  char *requires;
  char *suggests;
  char *obsoletes;
  char *conflicts;
  char *provides;
  char *rflags;
  char *summary;
  unsigned flag;
  Header h;
};

struct s_Transaction {
  rpmts ts;
  int count;
};

struct s_TransactionData {
  SV* callback_open;
  SV* callback_close;
  SV* callback_trans;
  SV* callback_uninst;
  SV* callback_inst;
  long min_delta;
  SV *data; /* chain with another data user provided */
};

typedef struct s_Transaction* URPM__DB;
typedef struct s_Transaction* URPM__Transaction;
typedef struct s_Package* URPM__Package;

#define FLAG_ID               0x001fffffU
#define FLAG_RATE             0x00e00000U
#define FLAG_BASE             0x01000000U
#define FLAG_SKIP             0x02000000U
#define FLAG_DISABLE_OBSOLETE 0x04000000U
#define FLAG_INSTALLED        0x08000000U
#define FLAG_REQUESTED        0x10000000U
#define FLAG_REQUIRED         0x20000000U
#define FLAG_UPGRADE          0x40000000U
#define FLAG_NO_HEADER_FREE   0x80000000U

#define FLAG_ID_MAX           0x001ffffe
#define FLAG_ID_INVALID       0x001fffff

#define FLAG_RATE_POS         21
#define FLAG_RATE_MAX         5
#define FLAG_RATE_INVALID     0


#define FILENAME_TAG 1000000
#define FILESIZE_TAG 1000001

#define FILTER_MODE_ALL_FILES     0
#define FILTER_MODE_CONF_FILES    2

/* promote epoch sense should be :
     0 for compability with old packages
     1 for rpm 4.2 and better new approach. */
#define PROMOTE_EPOCH_SENSE       1

static ssize_t write_nocheck(int fd, const void *buf, size_t count) {
  return write(fd, buf, count);
}
static const void* unused_variable(const void *p) {
  return p;
}

static int rpmError_callback_data;

int rpmError_callback() {
  write_nocheck(rpmError_callback_data, rpmlogMessage(), strlen(rpmlogMessage()));
  return RPMLOG_DEFAULT;
}

static int rpm_codeset_is_utf8 = 0;

static struct s_backup {
    char *ptr;
    char chr;
} char_backups[32];

static int BI = 0;

static void
backup_char(char *c) {
      char_backups[BI].chr = *c,
      *(char_backups[BI++].ptr = &(*c)) = 0; /* mark end of string to enable searching backwards */
}

static void
restore_chars() {
    for(; BI > 0; char_backups[BI].ptr = NULL)
	BI--, *char_backups[BI].ptr = char_backups[BI].chr;
}

static SV*
newSVpv_utf8(const char *s, STRLEN len)
{
  SV *sv = newSVpv(s, len);
  SvUTF8_on(sv);
  return sv;
}

static void
get_fullname_parts(URPM__Package pkg, char **name, char **version, char **release, char **arch, char **eos) {
  char *_version = NULL, *_release = NULL, *_arch = NULL, *_eos = NULL;
  int i, disttag = 0;
  char *tmp = pkg->info;
  for (i = 0; i < 4 && tmp != NULL; i++)
    tmp = strchr(++tmp, '@');
  if (tmp++ != NULL && *tmp != '@')
    disttag = 1;
  /* XXX: filename at end of line, don't bother to support it, just make sure
   * for it not to cause crash...
   */
  if ((tmp = strrchr(pkg->info, '.')) && !strcmp(tmp, ".rpm"))
    disttag = 0;

  if ((_eos = strchr(pkg->info, '@')) != NULL) {
    *_eos = 0; /* mark end of string to enable searching backwards */
    if ((_arch = strrchr(pkg->info, '.')) != NULL) {
      *_arch = 0;
      if ((release != NULL || version != NULL || name != NULL) && (_release = strrchr(pkg->info, '-')) != NULL) {
	if (disttag) {
	  tmp = _release;
	  while(tmp != _arch) {
	    backup_char(tmp++);
	  }
	  if((tmp = strrchr(pkg->info, '-'))) {
	    _release = tmp;
	  } else {
	    restore_chars();
	    croak("failed while eliminating distepoch, this should never happen! :(");
	  }
	}
	*_release = 0;
	if ((version != NULL || name != NULL) && (_version = strrchr(pkg->info, '-')) != NULL) {
	  if (name != NULL) *name = pkg->info;
	  if (version != NULL) *version = _version + 1;
	}
	if (release != NULL) *release = _release + 1;
	*_release = '-';
      }
      if (arch != NULL) *arch = _arch + 1;
      *_arch = '.';
    }
    if (eos != NULL) *eos = _eos;
    *_eos = '@';
  }
}

static char *
get_name(Header header, int32_t tag) {
  struct rpmtd_s val;

  headerGet(header, tag, &val, HEADERGET_MINMEM);
  char *name = (char *) rpmtdGetString(&val);
  return name ? name : "";
}

static int
get_int(Header header, int32_t tag) {
  struct rpmtd_s val;

  headerGet(header, tag, &val, HEADERGET_DEFAULT);
  uint32_t *ep = rpmtdGetUint32(&val);
  return ep ? *ep : 0;
}

static void
strip_distepoch(Header header, int32_t tag) {
  struct rpmtd_s val;

  headerGet(header, tag, &val, HEADERGET_DEFAULT);
  char **list = val.data;
  for (val.ix = 0; val.ix < (int)val.count; val.ix++) {
    char *tmp = strchr(list[val.ix], '-');
    if(tmp) {
      tmp = strchr(tmp, ':');
      if(tmp) {
	memset(tmp, 0, strlen(tmp));
      }
    }
  }
  headerMod(header, &val);
}

static void
pretend_distepoch(Header header, int32_t names_tag, int32_t flags_tag, int32_t versions_tag) {
  struct rpmtd_s names, flags, versions;
  char *EVR = headerFormat(header, "%|EPOCH?{%{EPOCH}:}|%{VERSION}-%{RELEASE}", NULL);

  headerGet(header, flags_tag, &flags, HEADERGET_DEFAULT);
  headerGet(header, versions_tag, &versions, HEADERGET_DEFAULT);

  char **name = NULL;
  char **name2 = NULL;
  int32_t *flag = flags.data;
  int32_t *flag2 = NULL;
  char **version = versions.data;
  char **version2 = NULL;

  for (flags.ix = 0; flags.ix < (int)flags.count; flags.ix++) {
    if(!(flag[flags.ix] & ((RPMSENSE_LESS|RPMSENSE_GREATER|~RPMSENSE_EQUAL))) && version[flags.ix] && *version[flags.ix] && !strcmp(EVR, version[flags.ix])) {
      if(!name) {
	headerGet(header, names_tag, &names, HEADERGET_DEFAULT);

	name = names.data;
	name2 = malloc(++names.count * sizeof(*name));
	names.data = memcpy(name2, name, sizeof(*name)*names.count);
	flag2 = malloc(names.count * sizeof(flag));
	flags.data = memcpy(flag2, flag, sizeof(flag)*names.count);
	version2 = malloc(names.count * sizeof(*version));
	versions.data = memcpy(version2, version, sizeof(*version)*names.count);
      } else {
	names.data = name2 = realloc(name2, sizeof(*name) * ++names.count);
	flags.data = flag2 = realloc(flag2,  sizeof(flag) * names.count);
	versions.data = version2 = realloc(version2, sizeof(*version) * names.count);
      }
      name2[names.count-1] = name[flags.ix];
      flag2[names.count-1] = (flag[flags.ix] | RPMSENSE_LESS) & ~RPMSENSE_EQUAL;
      flag2[flags.ix] |= RPMSENSE_GREATER;
      version2[names.count-1] = calloc(strlen(version[flags.ix])+2, 1);
      char *v = stpcpy(version2[names.count-1], version[flags.ix]);
      if (v[-1] == '9') {
	v[-1] = '1';
	v[0] = '0';
      } else
	(*(&v[-1]))++;
    }
  }
  if(name) {
    flags.count = versions.count = names.count;
    headerMod(header, &names);
    headerMod(header, &flags);
    headerMod(header, &versions);
    /*rpmtdFree(&names);*/
  }
  /*rpmtdFree(&flags);
  rpmtdFree(&versions);*/
}

static void
remap_suggests(Header header) {
  struct rpmtd_s list, flags, list_evr;

  if (headerGet(header, RPMTAG_REQUIREFLAGS, &flags, HEADERGET_DEFAULT)) {
    rpm_count_t count = 0;
    for(flags.ix = 0; flags.ix < (int)flags.count; flags.ix++)
      if(((uint32_t*)flags.data)[flags.ix] & RPMSENSE_MISSINGOK)
	count++;

    if(count) {
      if(headerGet(header, RPMTAG_REQUIRENAME, &list, HEADERGET_DEFAULT)) {
	headerGet(header, RPMTAG_REQUIREVERSION, &list_evr, HEADERGET_DEFAULT);
	struct rpmtd_s	list_sug, flags_sug, list_evr_sug;

	list_sug.tag = RPMTAG_SUGGESTSNAME;
	flags_sug.tag = RPMTAG_SUGGESTSFLAGS;
	list_evr_sug.tag = RPMTAG_SUGGESTSVERSION;
	list_sug.count = flags_sug.count = list_evr_sug.count = count;
	list_sug.type = list.type;
	flags_sug.type = flags_sug.type;
	list_evr_sug.type = list_evr_sug.type;
	list_sug.flags = list.flags;
	flags_sug.flags = flags.flags;
	list_evr_sug.flags = list_evr.flags;
	list_sug.data = malloc(count * sizeof(char*));
	flags_sug.data = malloc(count * sizeof(uint32_t));
	list_evr_sug.data = malloc(count * sizeof(char*));

	for(list.ix = flags.ix = flags_sug.ix = 0; flags.ix < (int)flags.count; flags.ix++) {
	  if(((uint32_t*)flags.data)[flags.ix] & RPMSENSE_MISSINGOK) {
	    ((char**)list_sug.data)[flags_sug.ix] = ((char**)list.data)[flags.ix];
	    ((uint32_t*)flags_sug.data)[flags_sug.ix] = ((uint32_t*)flags.data)[flags.ix];
	    ((char**)list_evr_sug.data)[flags_sug.ix] = ((char**)list_evr.data)[flags.ix];

	    flags_sug.ix++;
	    list.count--;
	  }
	  else {
	    ((char**)list.data)[list.ix] = ((char**)list.data)[flags.ix];
	    ((uint32_t*)flags.data)[list.ix] = ((uint32_t*)flags.data)[flags.ix];
	    ((char**)list_evr.data)[list.ix] = ((char**)list_evr.data)[flags.ix];
	    list.ix++;
	  }
	}
	flags.count = list_evr.count = list.count;

	headerMod(header, &list);
	headerMod(header, &flags);
	headerMod(header, &list_evr);
	headerPut(header, &list_sug, HEADERPUT_DEFAULT);
	/* XXX: unused
	 headerPut(header, &flags_sug, HEADERPUT_DEFAULT);
	 headerPut(header, &list_evr_sug, HEADERPUT_DEFAULT);
	 */

	rpmtdFreeData(&list);
	rpmtdFreeData(&list_evr);

	rpmtdFreeData(&list_sug);
	rpmtdFreeData(&flags_sug);
	rpmtdFreeData(&list_evr_sug);
      }
      rpmtdFreeData(&flags);
    }
  }
}

static void
convert_header(Header header) {
  if (header) {
    if (headerIsEntry(header, RPMTAG_DISTEPOCH)) {
      strip_distepoch(header, RPMTAG_PROVIDEVERSION);
      strip_distepoch(header, RPMTAG_REQUIREVERSION);
      strip_distepoch(header, RPMTAG_OBSOLETEVERSION);
      strip_distepoch(header, RPMTAG_CONFLICTVERSION);
    }
    remap_suggests(header);
  }
}

static int
sigsize_to_filesize(int sigsize) {
  return sigsize + 440; /* 440 is the rpm header size (?) empirical, but works */
}

static int
print_list_entry(char *buff, int sz, const char *name, uint32_t flags, const char *evr) {
  int len = strlen(name);
  char *p = buff;

  if (len >= sz || !strncmp(name, "rpmlib(", 7)) return -1;
  memcpy(p, name, len); p += len;

  if (flags & (RPMSENSE_PREREQ|RPMSENSE_SCRIPT_PREUN|RPMSENSE_SCRIPT_PRE|RPMSENSE_SCRIPT_POSTUN|RPMSENSE_SCRIPT_POST)) {
    if (p - buff + 3 >= sz) return -1;
    memcpy(p, "[*]", 4); p += 3;
  }
  if (evr != NULL) {
    len = strlen(evr);
    if (len > 0) {
      if (p - buff + 6 + len >= sz) return -1;
      *p++ = '[';
      if (flags & RPMSENSE_LESS) *p++ = '<';
      if (flags & RPMSENSE_GREATER) *p++ = '>';
      if (flags & RPMSENSE_EQUAL) *p++ = '=';
      if ((flags & (RPMSENSE_LESS|RPMSENSE_EQUAL|RPMSENSE_GREATER)) == RPMSENSE_EQUAL) *p++ = '=';
      *p++ = ' ';
      memcpy(p, evr, len); p+= len;
      *p++ = ']';
    }
  }
  *p = 0; /* make sure to mark null char, Is it really necessary ? */

  return p - buff;
}

static int
ranges_overlap(uint32_t aflags, char *sa, uint32_t bflags, char *sb, int b_nopromote) {
  if (!aflags || !bflags)
    return 1; /* really faster to test it there instead of later */
  else {
    int sense = 0;
    char *eosa = strchr(sa, ']');
    char *eosb = strchr(sb, ']');
    char *ea, *va, *ra, *da, *eb, *vb, *rb, *db;

    if (eosa) *eosa = 0;
    if (eosb) *eosb = 0;
    /* parse sa as an [epoch:]version[-release] */
    for (ea = sa; *sa >= '0' && *sa <= '9'; ++sa);
    if (*sa == ':') {
      *sa++ = 0; /* ea could be an empty string (should be interpreted as 0) */
      va = sa;
    } else {
      va = ea; /* no epoch */
      ea = NULL;
    }
    if ((ra = strrchr(sa, '-'))) *ra++ = 0;
    if (ra && (da = strchr(ra, ':'))) *da++ = 0;
    else da = NULL;

    /* parse sb as an [epoch:]version[-release] */
    for (eb = sb; *sb >= '0' && *sb <= '9'; ++sb);
    if (*sb == ':') {
      *sb++ = 0; /* ea could be an empty string (should be interpreted as 0) */
      vb = sb;
    } else {
      vb = eb; /* no epoch */
      eb = NULL;
    }
    if ((rb = strrchr(sb, '-'))) *rb++ = 0;
    if (rb && (db = strchr(rb, ':'))) *db++ = 0;
    else db = NULL;
    /* now compare epoch */
    if (ea && eb)
      sense = rpmvercmp(*ea ? ea : "0", *eb ? eb : "0");
    else if (ea && *ea && atol(ea) > 0)
      sense = b_nopromote ? 1 : 0;
    else if (eb && *eb && atol(eb) > 0)
      sense = -1;
    /* now compare version and release if epoch has not been enough */
    if (sense == 0) {
      sense = rpmvercmp(va, vb);
      if (sense == 0 && ra && *ra && rb && *rb)
	sense = rpmvercmp(ra, rb);
    }
    /* restore all character that have been modified inline */
    if (db) db[-1] = ':';
    if (da) da[-1] = ':';
    if (rb) rb[-1] = '-';
    if (ra) ra[-1] = '-';
    if (eb) vb[-1] = ':';
    if (ea) va[-1] = ':';
    if (eosb) *eosb = ']';
    if (eosa) *eosa = ']';
    /* finish the overlap computation */
    if (sense < 0 && ((aflags & RPMSENSE_GREATER) || (bflags & RPMSENSE_LESS)))
      return 1;
    else if (sense > 0 && ((aflags & RPMSENSE_LESS) || (bflags & RPMSENSE_GREATER)))
      return 1;
    else if (sense == 0 && (((aflags & RPMSENSE_EQUAL) && (bflags & RPMSENSE_EQUAL)) ||
			    ((aflags & RPMSENSE_LESS) && (bflags & RPMSENSE_LESS)) ||
			    ((aflags & RPMSENSE_GREATER) && (bflags & RPMSENSE_GREATER))))
      return 1;
    else
      return 0;
  }
}

static int has_old_suggests;
int32_t is_old_suggests(int32_t flags) { 
  int is = flags & RPMSENSE_MISSINGOK;
  if (is) has_old_suggests = is;
  return is;
}
int32_t is_not_old_suggests(int32_t flags) {
  return !is_old_suggests(flags);
}

typedef int (*callback_list_str)(char *s, int slen, const char *name, const uint32_t flags, const char *evr, void *param);

static int
callback_list_str_xpush(char *s, int slen, const char *name, uint32_t flags, const char *evr, __attribute__((unused)) void *param) {
  dSP;
  if (s) {
    XPUSHs(sv_2mortal(newSVpv(s, slen)));
  } else {
    char buff[4096];
    int len = print_list_entry(buff, sizeof(buff)-1, name, flags, evr);
    if (len >= 0)
      XPUSHs(sv_2mortal(newSVpv(buff, len)));
  }
  PUTBACK;
  /* returning zero indicates to continue processing */
  return 0;
}
static int
callback_list_str_xpush_requires(char *s, int slen, const char *name, const uint32_t flags, const char *evr, __attribute__((unused)) void *param) {
  dSP;
  if (s) {
    XPUSHs(sv_2mortal(newSVpv(s, slen)));
  } else if (is_not_old_suggests(flags)) {
    char buff[4096];
    int len = print_list_entry(buff, sizeof(buff)-1, name, flags, evr);
    if (len >= 0)
      XPUSHs(sv_2mortal(newSVpv(buff, len)));
  }
  PUTBACK;
  /* returning zero indicates to continue processing */
  return 0;
}
static int
callback_list_str_xpush_old_suggests(char *s, int slen, const char *name, uint32_t flags, const char *evr, __attribute__((unused)) void *param) {
  dSP;
  if (s) {
    XPUSHs(sv_2mortal(newSVpv(s, slen)));
  } else if (is_old_suggests(flags)) {
    char buff[4096];
    int len = print_list_entry(buff, sizeof(buff)-1, name, flags, evr);
    if (len >= 0)
      XPUSHs(sv_2mortal(newSVpv(buff, len)));
  }
  PUTBACK;
  /* returning zero indicates to continue processing */
  return 0;
}

struct cb_overlap_s {
  char *name;
  int32_t flags;
  char *evr;
  int direction; /* indicate to compare the above at left or right to the iteration element */
  int b_nopromote;
};

static int
callback_list_str_overlap(char *s, int slen, const char *name, uint32_t flags, const char *evr, void *param) {
  struct cb_overlap_s *os = (struct cb_overlap_s *)param;
  int result = 0;
  char *eos = NULL;
  char *eon = NULL;
  char eosc = '\0';
  char eonc = '\0';

  /* we need to extract name, flags and evr from a full sense information, store result in local copy */
  if (s) {
    if (slen) { eos = s + slen; eosc = *eos; *eos = 0; }
    name = s;
    while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
    if (*s) {
      eon = s;
      while (*s) {
	if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
	else if (*s == '<') flags |= RPMSENSE_LESS;
	else if (*s == '>') flags |= RPMSENSE_GREATER;
	else if (*s == '=') flags |= RPMSENSE_EQUAL;
	else break;
	++s;
      }
      evr = s;
    } else
      evr = "";
  }

  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* names should be equal, else it will not overlap */
  if (!strcmp(name, os->name)) {
    /* perform overlap according to direction needed, negative for left */
    if (os->direction < 0)
      result = ranges_overlap(os->flags, os->evr, flags, (char *) evr, os->b_nopromote);
    else
      result = ranges_overlap(flags, (char *) evr, os->flags, os->evr, os->b_nopromote);
  }

  /* fprintf(stderr, "cb_list_str_overlap result=%d, os->direction=%d, os->name=%s, os->evr=%s, name=%s, evr=%s\n",
     result, os->direction, os->name, os->evr, name, evr); */

  /* restore s if needed */
  if (eon) *eon = eonc;
  if (eos) *eos = eosc;

  return result;
}

static int
return_list_str(char *s, Header header, int32_t tag_name, int32_t tag_flags, int32_t tag_version, callback_list_str f, void *param) {
  int count = 0;

  if (s != NULL) {
    char *ps = strchr(s, '@');
    if (tag_flags && tag_version) {
      while(ps != NULL) {
	++count;
	char *tmp, *ps2 = NULL;
	if((tmp = strchr(s, '[')) &&
	    (tmp = strchr(tmp, '-')) &&
	    (tmp = strchr(tmp, ':')) &&
	    tmp < ps) {
	  backup_char(tmp);
	  *tmp = ']';
	  ps2 = ++tmp;
	} 
	if (f(s, ps2 ? ps2-s : ps-s, NULL, 0, NULL, param)) { restore_chars(); return -count; }
	restore_chars();
	s = ps + 1; ps = strchr(s, '@');
      }
      ++count;
      if((ps = strchr(s, '[')) &&
	  (ps = strchr(ps, '-')) &&
	  (ps = strchr(ps, ':'))) {
	backup_char(ps);
	*ps++ = ']';
      } 
      if (f(s, ps ? ps-s : 0, NULL, 0, NULL, param)) { restore_chars();	return -count; }
      restore_chars();
    } else {
      char *eos;
      while(ps != NULL) {
	*ps = 0; eos = strchr(s, '['); if (!eos) eos = strchr(s, ' ');
	++count;
	if (f(s, eos ? eos-s : ps-s, NULL, 0, NULL, param)) { *ps = '@'; return -count; }
	*ps = '@'; /* restore in memory modified char */
	s = ps + 1; ps = strchr(s, '@');
      }
      eos = strchr(s, '['); if (!eos) eos = strchr(s, ' ');
      ++count;
      if (f(s, eos ? eos-s : 0, NULL, 0, NULL, param)) return -count;
    }
  } else if (header) {
    struct rpmtd_s list, flags, list_evr;
    memset(&list, 0, sizeof(list));
    memset(&flags, 0, sizeof(flags));
    memset(&list_evr, 0, sizeof(list_evr));

    if (headerGet(header, tag_name, &list, HEADERGET_DEFAULT)) {
      if (tag_flags) headerGet(header, tag_flags, &flags, HEADERGET_DEFAULT);
      if (tag_version) headerGet(header, tag_version, &list_evr, HEADERGET_DEFAULT);
      while (rpmtdNext(&list) >= 0) {
	++count;
	uint32_t *flag = rpmtdNextUint32(&flags);
	if (f(NULL, 0, rpmtdGetString(&list), flag ? *flag : 0, 
	      rpmtdNextString(&list_evr), param)) {
	  rpmtdFreeData(&list);
	  if (tag_flags) rpmtdFreeData(&flags);
	  if (tag_version) rpmtdFreeData(&list_evr);
	  return -count;
	}
      }
      rpmtdFreeData(&list);
      if (tag_flags) rpmtdFreeData(&flags);
      if (tag_version) rpmtdFreeData(&list_evr);
    }
  }
  return count;
}

static int
xpush_simple_list_str(Header header, int32_t tag_name) {
  dSP;
  if (header) {
    struct rpmtd_s list;
    const char *val;
    int size;

    if (!headerGet(header, tag_name, &list, HEADERGET_DEFAULT)) return 0;
    size = rpmtdCount(&list);

    while ((val = rpmtdNextString(&list))) {
        XPUSHs(sv_2mortal(newSVpv(val, 0)));
    }
    rpmtdFreeData(&list);
    PUTBACK;
    return size;
  } else return 0;
}

void
return_list_int32_t(Header header, int32_t tag_name) {
  dSP;
  if (header) {
    struct rpmtd_s list;

    if (headerGet(header, tag_name, &list, HEADERGET_DEFAULT)) {
      uint32_t *val;
      while ((val = rpmtdNextUint32(&list)))
	XPUSHs(sv_2mortal(newSViv(*val)));
      rpmtdFreeData(&list);
    }
  }
  PUTBACK;
}

void
return_list_uint_16(Header header, int32_t tag_name) {
  dSP;
  if (header) {
    struct rpmtd_s list;
    if (headerGet(header, tag_name, &list, HEADERGET_DEFAULT)) {
      int count = rpmtdCount(&list);
      int i;
      uint16_t *list_ = list.data;
      for(i = 0; i < count; i++) {
	XPUSHs(sv_2mortal(newSViv(list_[i])));
      }
      rpmtdFreeData(&list);
    }
  }
  PUTBACK;
}

void
return_list_tag_modifier(Header header, int32_t tag_name) {
  dSP;
  int i;
  struct rpmtd_s td;
  if (!headerGet(header, tag_name, &td, HEADERGET_DEFAULT)) return;
  int count = rpmtdCount(&td);
  int32_t *list = td.data;

  for (i = 0; i < count; i++) {
    char buff[15];
    char *s = buff;
    switch (tag_name) {
    case RPMTAG_FILEFLAGS:
      if (list[i] & RPMFILE_CONFIG)    *s++ = 'c';
      if (list[i] & RPMFILE_DOC)       *s++ = 'd';
      if (list[i] & RPMFILE_GHOST)     *s++ = 'g';
      if (list[i] & RPMFILE_LICENSE)   *s++ = 'l';
      if (list[i] & RPMFILE_MISSINGOK) *s++ = 'm';
      if (list[i] & RPMFILE_NOREPLACE) *s++ = 'n';
      if (list[i] & RPMFILE_SPECFILE)  *s++ = 'S';
      if (list[i] & RPMFILE_README)    *s++ = 'R';
      if (list[i] & RPMFILE_EXCLUDE)   *s++ = 'e';
      if (list[i] & RPMFILE_ICON)      *s++ = 'i';
      if (list[i] & RPMFILE_UNPATCHED) *s++ = 'u';
      if (list[i] & RPMFILE_PUBKEY)    *s++ = 'p';
    break;
    default:
      rpmtdFreeData(&td);
      return;  
    }
    *s = '\0';
    XPUSHs(sv_2mortal(newSVpv(buff, strlen(buff))));
  }
  rpmtdFreeData(&td);
  PUTBACK;
}

void
return_list_tag(URPM__Package pkg, int32_t tag_name) {
  dSP;
  if (pkg->h != NULL) {
    struct rpmtd_s td;
    if (headerGet(pkg->h, tag_name, &td, HEADERGET_DEFAULT)) {
      void *list = td.data;
      int32_t count = rpmtdCount(&td);
      if (tag_name == RPMTAG_ARCH) {
	XPUSHs(sv_2mortal(newSVpv(headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? (char *) list : "src", 0)));
      } else
	switch (rpmtdType(&td)) {
	  case RPM_NULL_TYPE:
	    break;
#ifdef RPM_ORG
	  case RPM_CHAR_TYPE:
#endif
	  case RPM_INT8_TYPE:
	  case RPM_INT16_TYPE:
	  case RPM_INT32_TYPE:
	    {
	      int i;
	      int *r;
	      r = (int *)list;
	      for (i=0; i < count; i++) {
		XPUSHs(sv_2mortal(newSViv(r[i])));
	      }
	    }
	    break;
	  case RPM_STRING_TYPE:
	    XPUSHs(sv_2mortal(newSVpv((char *) list, 0)));
	    break;
	  case RPM_BIN_TYPE:
	    break;
	  case RPM_STRING_ARRAY_TYPE:
	    {
	      int i;
	      char **s;

	      s = (char **)list;
	      for (i = 0; i < count; i++) {
		XPUSHs(sv_2mortal(newSVpv(s[i], 0)));
	      }
	    }
	    break;
	  case RPM_I18NSTRING_TYPE:
	    break;
	  case RPM_INT64_TYPE:
	    break;
	}
    }
  } else {
    char *name;
    char *version;
    char *release;
    char *arch;
    char *eos;
    switch (tag_name) {
      case RPMTAG_NAME:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  if (version - name < 1) croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(name, version-name - 1)));
	}
	break;
      case RPMTAG_VERSION:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  if (release - version < 1) croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(version, release-version - 1)));
	}
	break;
      case RPMTAG_RELEASE:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  if (arch - release < 1) croak("invalid fullname");
	  XPUSHs(sv_2mortal(newSVpv(release, arch-release - 1)));
	}
	break;
      case RPMTAG_ARCH:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  XPUSHs(sv_2mortal(newSVpv(arch == eos ? "" : arch, eos-arch)));
	}
	break;
      case RPMTAG_SUMMARY:
	XPUSHs(sv_2mortal(newSVpv(pkg->summary, 0)));
	break;
    }
    restore_chars();
  }
  PUTBACK;
}


void
return_files(Header header, int filter_mode) {
  dSP;
  if (header) {
    char buff[4096];
    char *p, *s;
    STRLEN len;
    unsigned int i;

    struct rpmtd_s td_flags, td_fmodes;
    int32_t *flags = NULL;
    uint16_t *fmodes = NULL;
    if (filter_mode) {
      headerGet(header, RPMTAG_FILEFLAGS, &td_flags, HEADERGET_DEFAULT);
      headerGet(header, RPMTAG_FILEMODES, &td_fmodes, HEADERGET_DEFAULT);
      flags = td_flags.data;
      fmodes = td_fmodes.data;
    }

    struct rpmtd_s td_baseNames, td_dirIndexes, td_dirNames, td_list;
    headerGet(header, RPMTAG_BASENAMES, &td_baseNames, HEADERGET_DEFAULT);
    headerGet(header, RPMTAG_DIRINDEXES, &td_dirIndexes, HEADERGET_DEFAULT);
    headerGet(header, RPMTAG_DIRNAMES, &td_dirNames, HEADERGET_DEFAULT);

    char **baseNames = td_baseNames.data;
    char **dirNames = td_dirNames.data;
    int32_t *dirIndexes = td_dirIndexes.data;

    char **list = NULL;
    if (!baseNames || !dirNames || !dirIndexes) {
      if (!headerGet(header, RPMTAG_OLDFILENAMES, &td_list, HEADERGET_DEFAULT)) return;
      list = td_list.data;
    }

    for(i = 0; i < rpmtdCount(&td_baseNames); i++) {
      if (list) {
	s = list[i];
	len = strlen(list[i]);
      } else {
	len = strlen(dirNames[dirIndexes[i]]);
	if (len >= sizeof(buff)) continue;
	memcpy(p = buff, dirNames[dirIndexes[i]], len + 1); p += len;
	len = strlen(baseNames[i]);
	if (p - buff + len >= sizeof(buff)) continue;
	memcpy(p, baseNames[i], len + 1); p += len;
	s = buff;
	len = p-buff;
      }

      if (filter_mode) {
	if ((filter_mode & FILTER_MODE_CONF_FILES) && flags && (flags[i] & RPMFILE_CONFIG) == 0) continue;
      }

      XPUSHs(sv_2mortal(newSVpv(s, len)));
    }

    free(baseNames);
    free(dirNames);
    free(list);
  }
  PUTBACK;
}

void
return_problems(rpmps ps, int translate_message, int raw_message) {
  dSP;
  if (ps && rpmpsNumProblems(ps) > 0) {
    rpmpsi iterator = rpmpsInitIterator(ps);
    while (rpmpsNextIterator(iterator) >= 0) {
      rpmProblem p = rpmpsGetProblem(iterator);

      if (translate_message) {
	/* translate error using rpm localization */
	const char *buf = rpmProblemString(p);
	SV *sv = newSVpv(buf, 0);
	if (rpm_codeset_is_utf8) SvUTF8_on(sv);
	XPUSHs(sv_2mortal(sv));
	_free(buf);
      }
      if (raw_message) {
	const char *pkgNEVR = rpmProblemGetPkgNEVR(p) ? rpmProblemGetPkgNEVR(p) : "";
	const char *altNEVR = rpmProblemGetAltNEVR(p) ? rpmProblemGetAltNEVR(p) : "";
	const char *s = rpmProblemGetStr(p) ? rpmProblemGetStr(p) : "";
	SV *sv;

	switch (rpmProblemGetType(p)) {
	case RPMPROB_BADARCH:
	  sv = newSVpvf("badarch@%s", pkgNEVR); break;

	case RPMPROB_BADOS:
	  sv = newSVpvf("bados@%s", pkgNEVR); break;

	case RPMPROB_PKG_INSTALLED:
	  sv = newSVpvf("installed@%s", pkgNEVR); break;

	case RPMPROB_BADRELOCATE:
	  sv = newSVpvf("badrelocate@%s@%s", pkgNEVR, s); break;

	case RPMPROB_NEW_FILE_CONFLICT:
	case RPMPROB_FILE_CONFLICT:
	  sv = newSVpvf("conflicts@%s@%s@%s", pkgNEVR, altNEVR, s); break;

	case RPMPROB_OLDPACKAGE:
	  sv = newSVpvf("installed@%s@%s", pkgNEVR, altNEVR); break;

	case RPMPROB_DISKSPACE:
	  sv = newSVpvf("diskspace@%s@%s@%lld", pkgNEVR, s, (long long)rpmProblemGetDiskNeed(p)); break;
	case RPMPROB_DISKNODES:
	  sv = newSVpvf("disknodes@%s@%s@%lld", pkgNEVR, s, (long long)rpmProblemGetDiskNeed(p)); break;
	case RPMPROB_REQUIRES:
	  sv = newSVpvf("requires@%s@%s", pkgNEVR, altNEVR+2); break;

	case RPMPROB_CONFLICT:
	  sv = newSVpvf("conflicts@%s@%s", pkgNEVR, altNEVR+2); break;

	default:
	  sv = newSVpvf("unknown@%s", pkgNEVR); break;
	}
	XPUSHs(sv_2mortal(sv));
      }
    }
    rpmpsFreeIterator(iterator);
  }
  PUTBACK;
}

static char *
pack_list(Header header, int32_t tag_name, int32_t tag_flags, int32_t tag_version, int32_t (*check_flag)(int32_t)) {
  char buff[65536];
  int32_t *flags = NULL;
  char **list_evr = NULL;
  unsigned int i;
  char *p = buff;

  struct rpmtd_s td;
  if (headerGet(header, tag_name, &td, HEADERGET_DEFAULT)) {
    char **list = td.data;
    
    struct rpmtd_s td_flags, td_list_evr;
    if (tag_flags   && headerGet(header, tag_flags,   &td_flags, HEADERGET_DEFAULT))    flags    = td_flags.data;
    if (tag_version && headerGet(header, tag_version, &td_list_evr, HEADERGET_DEFAULT)) list_evr = td_list_evr.data;
    for(i = 0; i < rpmtdCount(&td); i++) {
      if (check_flag && !check_flag(flags[i])) continue;
      int len = print_list_entry(p, sizeof(buff)-(p-buff)-1, list[i], flags ? flags[i] : 0, list_evr ? list_evr[i] : NULL);
      if (len < 0) continue;
      p += len;
      *p++ = '@';
    }
    if (p > buff) p[-1] = 0;

    free(list);
    free(list_evr);
  }

  return p > buff ? memcpy(malloc(p-buff), buff, p-buff) : NULL;
}

static void
pack_header(URPM__Package pkg) {
  if (pkg->h) {
    if (pkg->info == NULL) {
      char buff[1024];
      char *p = buff;
      const char *group = get_name(pkg->h, RPMTAG_GROUP);
      const char *disttag = get_name(pkg->h, RPMTAG_DISTTAG);
      const char *distepoch = get_name(pkg->h, RPMTAG_DISTEPOCH);
      const char *nvra = headerFormat(pkg->h,
	  "%{NAME}-%{VERSION}-%{RELEASE}%|DISTTAG?{-%{DISTTAG}%|DISTEPOCH?"
	  "{%{DISTEPOCH}}|}|.%|ARCH?{%|SOURCERPM?{%{ARCH}}:{src}|}:{}|",
	  NULL
	  );
      p += snprintf(buff, sizeof(buff), "%s@%d@%d@%s", nvra,
		    get_int(pkg->h, RPMTAG_EPOCH), get_int(pkg->h, RPMTAG_SIZE), 
		    group);
      if (*disttag || *distepoch) {
	p = stpcpy(p, "@");
	if (*disttag)
	  p = stpcpy(p, disttag);
	p = stpcpy(p, "@");
	if (*distepoch)
	  p = stpcpy(p, distepoch);
      }
      *++p = '\0';
      pkg->info = memcpy(malloc(p-buff), buff, p-buff);
      _free(nvra);
    }
    if (pkg->filesize == 0) pkg->filesize = sigsize_to_filesize(get_int(pkg->h, RPMTAG_SIGSIZE));
    if (pkg->requires == NULL && pkg->suggests == NULL)
      has_old_suggests = 0;
      pkg->requires = pack_list(pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION, is_not_old_suggests);
      if (has_old_suggests)
      pkg->suggests = pack_list(pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION, is_old_suggests);
      else
        pkg->suggests = pack_list(pkg->h, RPMTAG_SUGGESTSNAME, 0, 0, NULL);
    if (pkg->obsoletes == NULL)
      pkg->obsoletes = pack_list(pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION, NULL);
    if (pkg->conflicts == NULL)
      pkg->conflicts = pack_list(pkg->h, RPMTAG_CONFLICTNAME, RPMTAG_CONFLICTFLAGS, RPMTAG_CONFLICTVERSION, NULL);
    if (pkg->provides == NULL)
      pkg->provides = pack_list(pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION, NULL);
    if (pkg->summary == NULL) {
      char *summary = get_name(pkg->h, RPMTAG_SUMMARY);
      int len = 1 + strlen(summary);

      pkg->summary = memcpy(malloc(len), summary, len);
    }

    if (!(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h =headerFree(pkg->h);
    pkg->h = 0;
  }
}

static void
update_hash_entry(HV *hash, char *name, STRLEN len, int force, IV use_sense, URPM__Package pkg) {
  SV** isv;

  if (!len) len = strlen(name);
  if ((isv = hv_fetch(hash, name, len, force))) {
    /* check if an entry has been found or created, it should so be updated */
    if (!SvROK(*isv) || SvTYPE(SvRV(*isv)) != SVt_PVHV) {
      SV* choice_set = (SV*)newHV();
      if (choice_set) {
	SvREFCNT_dec(*isv); /* drop the old as we are changing it */
	if (!(*isv = newRV_noinc(choice_set))) {
	  SvREFCNT_dec(choice_set);
	  *isv = &PL_sv_undef;
	}
      }
    }
    if (isv && *isv != &PL_sv_undef) {
      char id[8];
      STRLEN id_len = snprintf(id, sizeof(id), "%d", pkg->flag & FLAG_ID);
      SV **sense = hv_fetch((HV*)SvRV(*isv), id, id_len, 1);
      if (sense && use_sense) sv_setiv(*sense, use_sense);
    }
  }
}

static void
update_provide_entry(char *name, STRLEN len, int force, IV use_sense, URPM__Package pkg, HV *provides) {
  update_hash_entry(provides, name, len, force, use_sense, pkg);
}

static void
update_provides(URPM__Package pkg, HV *provides) {
  if (pkg->h) {
    int len;
    struct rpmtd_s td, td_flags;
    int32_t *flags = NULL;
    unsigned int i;

    /* examine requires for files which need to be marked in provides */
    if (headerGet(pkg->h, RPMTAG_REQUIRENAME, &td, HEADERGET_DEFAULT)) {
      char **list = td.data;
      for (i = 0; i < rpmtdCount(&td); ++i) {
	len = strlen(list[i]);
	if (list[i][0] == '/') (void)hv_fetch(provides, list[i], len, 1);
      }
    }

    /* update all provides */
    if (headerGet(pkg->h, RPMTAG_PROVIDENAME, &td, HEADERGET_DEFAULT)) {
      char **list = td.data;
      if (headerGet(pkg->h, RPMTAG_PROVIDEFLAGS, &td_flags, HEADERGET_DEFAULT))
	flags = td_flags.data;
      for (i = 0; i < rpmtdCount(&td); ++i) {
	len = strlen(list[i]);
	if (!strncmp(list[i], "rpmlib(", 7)) continue;
	update_provide_entry(list[i], len, 1, flags && flags[i] & (RPMSENSE_PREREQ|RPMSENSE_SCRIPT_PREUN|RPMSENSE_SCRIPT_PRE|RPMSENSE_SCRIPT_POSTUN|RPMSENSE_SCRIPT_POST|RPMSENSE_LESS|RPMSENSE_EQUAL|RPMSENSE_GREATER),
			     pkg, provides);
      }
    }
  } else {
    char *ps, *s, *es;

    if ((s = pkg->requires) != NULL && *s != 0) {
      ps = strchr(s, '@');
      while(ps != NULL) {
	if (s[0] == '/') {
	  *ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	  (void)hv_fetch(provides, s, es != NULL ? es-s : ps-s, 1);
	}
	s = ps + 1; ps = strchr(s, '@');
      }
      if (s[0] == '/') {
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
	(void)hv_fetch(provides, s, es != NULL ? (U32)(es-s) : strlen(s), 1);
      }
    }

    if ((s = pkg->provides) != NULL && *s != 0) {
      char *es;

      ps = strchr(s, '@');
      while(ps != NULL) {
	*ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	update_provide_entry(s, es != NULL ? es-s : ps-s, 1, es != NULL, pkg, provides);
	s = ps + 1; ps = strchr(s, '@');
      }
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
      update_provide_entry(s, es != NULL ? es-s : 0, 1, es != NULL, pkg, provides);
    }
  }
}

static void
update_obsoletes(URPM__Package pkg, HV *obsoletes) {
  if (pkg->h) {
    struct rpmtd_s td;

    /* update all provides */
    if (headerGet(pkg->h, RPMTAG_OBSOLETENAME, &td, HEADERGET_DEFAULT)) {
      char **list = td.data;
      unsigned int i;
      for (i = 0; i < rpmtdCount(&td); ++i)
	update_hash_entry(obsoletes, list[i], 0, 1, 0, pkg);
    }
  } else {
    char *ps, *s;

    if ((s = pkg->obsoletes) != NULL && *s != 0) {
      char *es;

      ps = strchr(s, '@');
      while(ps != NULL) {
	*ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	update_hash_entry(obsoletes, s, es != NULL ? es-s : ps-s, 1, 0, pkg);
	s = ps + 1; ps = strchr(s, '@');
      }
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
      update_hash_entry(obsoletes, s, es != NULL ? es-s : 0, 1, 0, pkg);
    }
  }
}

static void
update_provides_files(URPM__Package pkg, HV *provides) {
  if (pkg->h) {
    STRLEN len;
    char **list = NULL;
    unsigned int i;

    struct rpmtd_s td_baseNames, td_dirIndexes, td_dirNames;
    if (headerGet(pkg->h, RPMTAG_BASENAMES, &td_baseNames, HEADERGET_DEFAULT) &&
	headerGet(pkg->h, RPMTAG_DIRINDEXES, &td_dirIndexes, HEADERGET_DEFAULT) &&
	headerGet(pkg->h, RPMTAG_DIRNAMES, &td_dirNames, HEADERGET_DEFAULT)) {

      char **baseNames = td_baseNames.data;
      char **dirNames = td_dirNames.data;
      int32_t *dirIndexes = td_dirIndexes.data;

      char buff[4096];
      char *p;

      for(i = 0; i < rpmtdCount(&td_baseNames); i++) {
	len = strlen(dirNames[dirIndexes[i]]);
	if (len >= sizeof(buff)) continue;
	memcpy(p = buff, dirNames[dirIndexes[i]], len + 1); p += len;
	len = strlen(baseNames[i]);
	if (p - buff + len >= sizeof(buff)) continue;
	memcpy(p, baseNames[i], len + 1); p += len;

	update_provide_entry(buff, p-buff, 0, 0, pkg, provides);
      }

      free(baseNames);
      free(dirNames);
    } else {
      struct rpmtd_s td;
      headerGet(pkg->h, RPMTAG_OLDFILENAMES, &td, HEADERGET_DEFAULT);
      if (list) {
	for (i = 0; i < rpmtdCount(&td); i++) {
	  len = strlen(list[i]);

	  update_provide_entry(list[i], len, 0, 0, pkg, provides);
	}

	free(list);
      }
    }
  }
}

int
open_archive(char *filename, pid_t *pid, int *empty_archive) {
  int fd;
  struct {
    char header[4];
    char toc_d_count[4];
    char toc_l_count[4];
    char toc_f_count[4];
    char toc_str_size[4];
    char uncompress[40];
    char trailer[4];
  } buf;

  fd = open(filename, O_RDONLY);
  if (fd >= 0) {
    int pos = lseek(fd, -(int)sizeof(buf), SEEK_END);
    if (read(fd, &buf, sizeof(buf)) != sizeof(buf) || strncmp(buf.header, "cz[0", 4) || strncmp(buf.trailer, "0]cz", 4)) {
      /* this is not an archive, open it without magic, but first rewind at begin of file */
      lseek(fd, 0, SEEK_SET);
    } else if (pos == 0) {
      *empty_archive = 1;
      fd = -1;
    } else {
      /* this is an archive, create a pipe and fork for reading with uncompress defined inside */
      int fdno[2];

      if (!pipe(fdno)) {
	if ((*pid = fork()) != 0) {
	  fd_set readfds;
	  struct timeval timeout;

	  FD_ZERO(&readfds);
	  FD_SET(fdno[0], &readfds);
	  timeout.tv_sec = 1;
	  timeout.tv_usec = 0;
	  select(fdno[0]+1, &readfds, NULL, NULL, &timeout);

	  close(fd);
	  fd = fdno[0];
	  close(fdno[1]);
	} else {
	  char *unpacker[22]; /* enough for 40 bytes in uncompress to never overbuf */
	  char *p = buf.uncompress;
	  int ip = 0;
	  char *ld_loader = getenv("LD_LOADER");

	  if (ld_loader && *ld_loader) {
	    unpacker[ip++] = ld_loader;
	  }

	  buf.trailer[0] = 0; /* make sure end-of-string is right */
	  while (*p) {
	    if (*p == ' ' || *p == '\t') *p++ = 0;
	    else {
	      unpacker[ip++] = p;
	      while (*p && *p != ' ' && *p != '\t') ++p;
	    }
	  }
	  unpacker[ip] = NULL; /* needed for execlp */

	  lseek(fd, 0, SEEK_SET);
	  dup2(fd, STDIN_FILENO); close(fd);
	  dup2(fdno[1], STDOUT_FILENO); close(fdno[1]);

	  /* get rid of "decompression OK, trailing garbage ignored" */
	  fd = open("/dev/null", O_WRONLY);
	  dup2(fd, STDERR_FILENO); close(fd);

	  execvp(unpacker[0], unpacker);
	  exit(1);
	}
      } else {
	close(fd);
	fd = -1;
      }
    }
  }
  return fd;
}

static int
call_package_callback(SV *urpm, SV *sv_pkg, SV *callback) {
  if (sv_pkg != NULL && callback != NULL) {
    int count;

    /* now, a callback will be called for sure */
    dSP;
    PUSHMARK(SP);
    XPUSHs(urpm);
    XPUSHs(sv_pkg);
    PUTBACK;
    count = call_sv(callback, G_SCALAR);
    SPAGAIN;
    if (count == 1 && !POPi) {
      /* package should not be added in depslist, so we free it */
      SvREFCNT_dec(sv_pkg);
      sv_pkg = NULL;
    }
    PUTBACK;
  }

  return sv_pkg != NULL;
}

static int
parse_line(AV *depslist, HV *provides, HV *obsoletes, URPM__Package pkg, char *buff, SV *urpm, SV *callback) {
  SV *sv_pkg;
  URPM__Package _pkg;
  char *tag, *data;
  int data_len;

  if (buff[0] == 0) {
    return 1;
  } else if ((tag = buff)[0] == '@' && (data = strchr(tag+1, '@')) != NULL) {
    *tag++ = *data++ = 0;
    data_len = 1+strlen(data);
    if (!strcmp(tag, "info")) {
      pkg->info = memcpy(malloc(data_len), data, data_len);
      pkg->flag &= ~FLAG_ID;
      pkg->flag |= 1 + av_len(depslist);
      sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package",
			    _pkg = memcpy(malloc(sizeof(struct s_Package)), pkg, sizeof(struct s_Package)));
      if (call_package_callback(urpm, sv_pkg, callback)) {
	if (provides) update_provides(_pkg, provides);
	if (obsoletes) update_obsoletes(_pkg, obsoletes);
	av_push(depslist, sv_pkg);
      }
      memset(pkg, 0, sizeof(struct s_Package));
    } else if (!strcmp(tag, "filesize")) {
      pkg->filesize = atoi(data);
    } else if (!strcmp(tag, "requires")) {
      free(pkg->requires); pkg->requires = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "suggests")) {
      free(pkg->suggests); pkg->suggests = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "obsoletes")) {
      free(pkg->obsoletes); pkg->obsoletes = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "conflicts")) {
      free(pkg->conflicts); pkg->conflicts = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "provides")) {
      free(pkg->provides); pkg->provides = memcpy(malloc(data_len), data, data_len);
    } else if (!strcmp(tag, "summary")) {
      free(pkg->summary); pkg->summary = memcpy(malloc(data_len), data, data_len);
    }
    return 1;
  } else {
    fprintf(stderr, "bad line <%s>\n", buff);
    return 0;
  }
}

#if 0
static void pack_rpm_header(Header *h) {
  Header packed = headerNew();

  HeaderIterator hi = headerInitIterator(*h);
  struct rpmtd_s td;
  while (headerNext(hi, &td)) {
      // fprintf(stderr, "adding %s %d\n", tagname(tag), c);
      headerPut(packed, &td, HEADERPUT_DEFAULT);
      rpmtdFreeData(&td);
  }

  headerFreeIterator(hi);
  *h = headerFree(*h);

  *h = packed;
}

static void drop_tags(Header *h) {
  headerDel(*h, RPMTAG_FILEUSERNAME); /* user ownership is correct */
  headerDel(*h, RPMTAG_FILEGROUPNAME); /* group ownership is correct */
  headerDel(*h, RPMTAG_FILEMTIMES); /* correct time without it */
  headerDel(*h, RPMTAG_FILEINODES); /* hardlinks work without it */
  headerDel(*h, RPMTAG_FILEDEVICES); /* it is the same number for every file */
  headerDel(*h, RPMTAG_FILESIZES); /* ? */
  headerDel(*h, RPMTAG_FILERDEVS); /* it seems unused. always empty */
  headerDel(*h, RPMTAG_FILEVERIFYFLAGS); /* only used for -V */
#ifndef RPM_ORG
  headerDel(*h, RPMTAG_FILEDIGESTALGOS); /* only used for -V */
  headerDel(*h, RPMTAG_FILEDIGESTS); /* only used for -V */ /* alias: RPMTAG_FILEMD5S */ 
#endif
  /* keep RPMTAG_FILEFLAGS for %config (rpmnew) to work */
  /* keep RPMTAG_FILELANGS for %lang (_install_langs) to work */
  /* keep RPMTAG_FILELINKTOS for checking conflicts between symlinks */
  /* keep RPMTAG_FILEMODES otherwise it segfaults with excludepath */

  /* keep RPMTAG_POSTIN RPMTAG_POSTUN RPMTAG_PREIN RPMTAG_PREUN */
  /* keep RPMTAG_TRIGGERSCRIPTS RPMTAG_TRIGGERVERSION RPMTAG_TRIGGERFLAGS RPMTAG_TRIGGERNAME */
  /* small enough, and only in some packages. not needed per se */

  headerDel(*h, RPMTAG_ICON);
  headerDel(*h, RPMTAG_GIF);
  headerDel(*h, RPMTAG_EXCLUDE);
  headerDel(*h, RPMTAG_EXCLUSIVE);
  headerDel(*h, RPMTAG_COOKIE);
  headerDel(*h, RPMTAG_VERIFYSCRIPT);

  /* always the same for our packages */
  headerDel(*h, RPMTAG_VENDOR);
  headerDel(*h, RPMTAG_DISTRIBUTION);

  /* keep RPMTAG_SIGSIZE, useful to tell the size of the rpm file (+440) */

  headerDel(*h, RPMTAG_DSAHEADER);
  headerDel(*h, RPMTAG_SHA1HEADER);
  headerDel(*h, RPMTAG_SIGMD5);
  headerDel(*h, RPMTAG_SIGGPG);

  pack_rpm_header(h);
}
#endif

static int
update_header(char *filename, URPM__Package pkg, __attribute__((unused)) int keep_all_tags, int vsflags) {
  int d = open(filename, O_RDONLY);

  if (d >= 0) {
    unsigned char sig[4];

    if (read(d, &sig, sizeof(sig)) == sizeof(sig)) {
      lseek(d, 0, SEEK_SET);
      if (sig[0] == 0xed && sig[1] == 0xab && sig[2] == 0xee && sig[3] == 0xdb) {
	FD_t fd = fdDup(d);
	Header header;
	rpmts ts;

	close(d);
	ts = rpmtsCreate();
	rpmtsSetVSFlags(ts, _RPMVSF_NOSIGNATURES | vsflags);
	if (fd != NULL && rpmReadPackageFile(ts, fd, filename, &header) == 0 && header) {
	  char *basename;
#ifndef RPM_ORG
	  struct stat sb;
#else
	  int32_t size;
#endif

	  basename = strrchr(filename, '/');
#ifndef RPM_ORG
	  Fstat(fd, &sb);
#else
	  size = fdSize(fd);
#endif
	  Fclose(fd);

	  /* this is only kept for compatibility with older distros
	     (where ->filename on "unpacked" URPM::Package rely on FILENAME_TAG) */
	  headerPutString(header, FILENAME_TAG, basename != NULL ? basename + 1 : filename);

	  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h = headerFree(pkg->h);
	  pkg->h = header;
	  pkg->flag &= ~FLAG_NO_HEADER_FREE;

	  /*if (!keep_all_tags) drop_tags(&pkg->h);*/
	  (void)rpmtsFree(ts);
	  return 1;
	}
	(void)rpmtsFree(ts);
      } else if (sig[0] == 0x8e && sig[1] == 0xad && sig[2] == 0xe8 && sig[3] == 0x01) {
	FD_t fd = fdDup(d);

	close(d);
	if (fd != NULL) {
	  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h = headerFree(pkg->h);
	  pkg->h = headerRead(fd, HEADER_MAGIC_YES);
	  
	  pkg->flag &= ~FLAG_NO_HEADER_FREE;
	  Fclose(fd);
	  return 1;
	}
      }
    }
  }
  return 0;
}

static int
read_config_files(int force) {
  static int already = 0;
  int rc = 0;

  if (!already || force) {
    rc = rpmReadConfigFiles(NULL, NULL);
    already = (rc == 0); /* set config as load only if it succeed */
  }
  return rc;
}

static void
ts_nosignature(rpmts ts) {
  rpmtsSetVSFlags(ts, _RPMVSF_NODIGESTS | _RPMVSF_NOSIGNATURES);
}

static void *rpmRunTransactions_callback(__attribute__((unused)) const void *h,
					 const rpmCallbackType what, 
					 const rpm_loff_t amount, 
					 const rpm_loff_t total,
					 fnpyKey pkgKey,
					 rpmCallbackData data) {
  static struct timeval tprev;
  static struct timeval tcurr;
  static FD_t fd = NULL;
  long delta;
  int i;
  struct s_TransactionData *td = data;
  SV *callback = NULL;
  char *callback_type = NULL;
  char *callback_subtype = NULL;

  if (!td)
    return NULL;

  switch (what) {
    case RPMCALLBACK_INST_OPEN_FILE:
      callback = td->callback_open;
      callback_type = "open";
      break;
    case RPMCALLBACK_INST_CLOSE_FILE:
      callback = td->callback_close;
      callback_type = "close";
      break;
    case RPMCALLBACK_TRANS_START:
    case RPMCALLBACK_TRANS_PROGRESS:
    case RPMCALLBACK_TRANS_STOP:
      callback = td->callback_trans;
      callback_type = "trans";
      break;
    case RPMCALLBACK_UNINST_START:
    case RPMCALLBACK_UNINST_PROGRESS:
    case RPMCALLBACK_UNINST_STOP:
      callback = td->callback_uninst;
      callback_type = "uninst";
      break;
    case RPMCALLBACK_INST_START:
    case RPMCALLBACK_INST_PROGRESS:
      callback = td->callback_inst;
      callback_type = "inst";
      break;
    default:
      break;
  }

  if (callback != NULL) {
    switch (what) {
      case RPMCALLBACK_TRANS_START:
      case RPMCALLBACK_UNINST_START:
      case RPMCALLBACK_INST_START:
	callback_subtype = "start";
	gettimeofday(&tprev, NULL);
	break;
      case RPMCALLBACK_TRANS_PROGRESS:
      case RPMCALLBACK_UNINST_PROGRESS:
      case RPMCALLBACK_INST_PROGRESS:
	callback_subtype = "progress";
	gettimeofday(&tcurr, NULL);
	delta = 1000000 * (tcurr.tv_sec - tprev.tv_sec) + (tcurr.tv_usec - tprev.tv_usec);
	if (delta < td->min_delta && amount < total - 1)
	  callback = NULL; /* avoid calling too often a given callback */
	else
	  tprev = tcurr;
	break;
      case RPMCALLBACK_TRANS_STOP:
      case RPMCALLBACK_UNINST_STOP:
	callback_subtype = "stop";
	break;
      default:
	break;
    }

    if (callback != NULL) {
      /* now, a callback will be called for sure */
      dSP;
      ENTER;
      SAVETMPS;
      PUSHMARK(SP);
      XPUSHs(td->data);
      XPUSHs(sv_2mortal(newSVpv(callback_type, 0)));
      XPUSHs(pkgKey != NULL ? sv_2mortal(newSViv((long)pkgKey - 1)) : &PL_sv_undef);
      if (callback_subtype != NULL) {
	XPUSHs(sv_2mortal(newSVpv(callback_subtype, 0)));
	XPUSHs(sv_2mortal(newSViv(amount)));
	XPUSHs(sv_2mortal(newSViv(total)));
      }
      PUTBACK;
      i = call_sv(callback, callback == td->callback_open ? G_SCALAR : G_DISCARD);
      SPAGAIN;
      if (callback == td->callback_open) {
	if (i != 1) croak("callback_open should return a file handle");
	i = POPi;
	fd = fdDup(i);
	if (fd) {
	  fd = fdLink(fd, "persist perl-URPM");
	  Fcntl(fd, F_SETFD, (void *)1); /* necessary to avoid forked/execed process to lock removable */
	}
	PUTBACK;
      } else if (callback == td->callback_close) {
	fd = fdFree(fd, "persist perl-URPM");
	if (fd) {
	  Fclose(fd);
	  fd = NULL;
	}
      }
      FREETMPS;
      LEAVE;
    }
  }
  return callback == td->callback_open ? fd : NULL;
}

int rpmtag_from_string(char *tag)
{
    if (!strcmp(tag, "name"))
      return RPMTAG_NAME;
    else if (!strcmp(tag, "whatprovides"))
      return RPMTAG_PROVIDENAME;
    else if (!strcmp(tag, "whatrequires"))
      return RPMTAG_REQUIRENAME;
    else if (!strcmp(tag, "whatconflicts"))
      return RPMTAG_CONFLICTNAME;
    else if (!strcmp(tag, "group"))
      return RPMTAG_GROUP;
    else if (!strcmp(tag, "triggeredby"))
      return RPMTAG_TRIGGERNAME;
    else if (!strcmp(tag, "path"))
      return RPMTAG_BASENAMES;
    else croak("unknown tag [%s]", tag);
}

#line 1682 "URPM.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

#line 1725 "URPM.c"

XS(XS_URPM__Package_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"URPM::Package::DESTROY",
			"pkg");
#line 1678 "URPM.xs"
  free(pkg->info);
  free(pkg->requires);
  free(pkg->suggests);
  free(pkg->obsoletes);
  free(pkg->conflicts);
  free(pkg->provides);
  free(pkg->rflags);
  free(pkg->summary);
  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h = headerFree(pkg->h);
  free(pkg);
#line 1759 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::name",
			"pkg", "URPM::Package");
#line 1693 "URPM.xs"
  if (pkg->info) {
    char *name;
    char *version;

    get_fullname_parts(pkg, &name, &version, NULL, NULL, NULL);
    if (version - name < 1) croak("invalid fullname");
    XPUSHs(sv_2mortal(newSVpv(name, version-name-1)));
    restore_chars();
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_NAME), 0)));
  }
#line 1800 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::version",
			"pkg", "URPM::Package");
#line 1709 "URPM.xs"
  if (pkg->info) {
    char *version;
    char *release;

    get_fullname_parts(pkg, NULL, &version, &release, NULL, NULL);
    if (release - version < 1) croak("invalid fullname");
    XPUSHs(sv_2mortal(newSVpv(version, release-version-1)));
    restore_chars();
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_VERSION), 0)));
  }
#line 1842 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_release); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_release)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::release",
			"pkg", "URPM::Package");
#line 1725 "URPM.xs"
  if (pkg->info) {
    char *release;
    char *arch;

    get_fullname_parts(pkg, NULL, NULL, &release, &arch, NULL);
    if (arch - release < 1) croak("invalid fullname");
    XPUSHs(sv_2mortal(newSVpv(release, arch[-2] ? arch-release-1 : 0)));
    restore_chars();
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_RELEASE), 0)));
  }
#line 1884 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_arch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_arch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::arch",
			"pkg", "URPM::Package");
#line 1741 "URPM.xs"
  if (pkg->info) {
    char *arch;
    char *eos;

    get_fullname_parts(pkg, NULL, NULL, NULL, &arch, &eos);
    XPUSHs(sv_2mortal(newSVpv(arch == eos ? "" : arch, eos-arch)));
    restore_chars();
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? get_name(pkg->h, RPMTAG_ARCH) : "src", 0)));
  }
#line 1925 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_is_arch_compat__XS); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_is_arch_compat__XS)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::is_arch_compat__XS",
			"pkg", "URPM::Package");
#line 1756 "URPM.xs"
#ifndef RPM_ORG
  char * platform;
#endif
#line 1959 "URPM.c"
#line 1760 "URPM.xs"
  read_config_files(0);
  if (pkg->info) {
    char *arch;
    char *eos;

    get_fullname_parts(pkg, NULL, NULL, NULL, &arch, &eos);
    *eos = 0;
#ifndef RPM_ORG
    platform = rpmExpand(arch, "-%{_target_vendor}-%{_target_os}%{?_gnu}", NULL);
    RETVAL = rpmPlatformScore(platform, NULL, 0);
    _free(platform);
#else
    RETVAL = rpmMachineScore(RPM_MACHTABLE_INSTARCH, arch);
#endif
    *eos = '@';
  } else if (pkg->h && headerIsEntry(pkg->h, RPMTAG_SOURCERPM)) {
    char *arch = get_name(pkg->h, RPMTAG_ARCH);
#ifndef RPM_ORG
    platform = rpmExpand(arch, "-%{_target_vendor}-%{_target_os}%{?_gnu}", NULL);
    RETVAL = rpmPlatformScore(platform, NULL, 0);
    _free(platform);
#else
    RETVAL = rpmMachineScore(RPM_MACHTABLE_INSTARCH, arch);
#endif
    restore_chars();
  } else {
    RETVAL = 0;
  }
#line 1989 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_is_platform_compat); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_is_platform_compat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::is_platform_compat",
			"pkg", "URPM::Package");
#line 1795 "URPM.xs"
#ifndef RPM_ORG
  char * platform = NULL;
  struct rpmtd_s val;
#endif
#line 2024 "URPM.c"
#line 1800 "URPM.xs"
#ifndef RPM_ORG
  read_config_files(0);
  if (pkg->h && headerIsEntry(pkg->h, RPMTAG_PLATFORM)) {
    (void) headerGet(pkg->h, RPMTAG_PLATFORM, &val, HEADERGET_DEFAULT);
    platform = (char *) rpmtdGetString(&val);
    RETVAL = rpmPlatformScore(platform, NULL, 0);
    platform = headerFreeData(platform, val.type);
  } else if (pkg->info) {
    char *arch;
    char *eos;

    get_fullname_parts(pkg, NULL, NULL, NULL, &arch, &eos);
    *eos = 0;
    platform = rpmExpand(arch, "-%{_target_vendor}-", eos, "%{?_gnu}", NULL);
    RETVAL = rpmPlatformScore(platform, NULL, 0);
    *eos = '@';
    _free(platform);
    restore_chars();
  } else { 
#else
    croak("is_platform_compat() is available only since rpm 4.4.8");
    { /* to match last } and avoid another #ifdef for it */
#endif
    RETVAL = 0;
    }

#line 2052 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_summary); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_summary)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::summary",
			"pkg", "URPM::Package");
#line 1833 "URPM.xs"
  if (pkg->summary) {
    XPUSHs(sv_2mortal(newSVpv_utf8(pkg->summary, 0)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_SUMMARY), 0)));
  }
#line 2088 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::description",
			"pkg", "URPM::Package");
#line 1843 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_DESCRIPTION), 0)));
  }
#line 2122 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_sourcerpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_sourcerpm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::sourcerpm",
			"pkg", "URPM::Package");
#line 1851 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_SOURCERPM), 0)));
  }
#line 2156 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_packager); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_packager)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::packager",
			"pkg", "URPM::Package");
#line 1859 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_PACKAGER), 0)));
  }
#line 2190 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_buildhost); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildhost)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::buildhost",
			"pkg", "URPM::Package");
#line 1867 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_BUILDHOST), 0)));
  }
#line 2224 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_buildtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildtime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::buildtime",
			"pkg", "URPM::Package");
#line 1875 "URPM.xs"
  if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_BUILDTIME);
  } else {
    RETVAL = 0;
  }
#line 2260 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_installtid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_installtid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::installtid",
			"pkg", "URPM::Package");
#line 1887 "URPM.xs"
  if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_INSTALLTID);
  } else {
    RETVAL = 0;
  }
#line 2296 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_url); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_url)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::url",
			"pkg", "URPM::Package");
#line 1899 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_URL), 0)));
  }
#line 2330 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_license); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_license)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::license",
			"pkg", "URPM::Package");
#line 1907 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_LICENSE), 0)));
  }
#line 2364 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_distribution); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_distribution)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::distribution",
			"pkg", "URPM::Package");
#line 1915 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_DISTRIBUTION), 0)));
  }
#line 2398 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_vendor); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_vendor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::vendor",
			"pkg", "URPM::Package");
#line 1923 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_VENDOR), 0)));
  }
#line 2432 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_os); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_os)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::os",
			"pkg", "URPM::Package");
#line 1931 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_OS), 0)));
  }
#line 2466 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_payload_format); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_payload_format)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::payload_format",
			"pkg", "URPM::Package");
#line 1939 "URPM.xs"
  if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_PAYLOADFORMAT), 0)));
  }
#line 2500 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_fullname); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_fullname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 1947 "URPM.xs"
  I32 gimme = GIMME_V;
#line 2523 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::fullname",
			"pkg", "URPM::Package");
#line 1949 "URPM.xs"
  if (pkg->info) {
    if (gimme == G_SCALAR) {
      char *eos;
      if ((eos = strchr(pkg->info, '@')) != NULL) {
	XPUSHs(sv_2mortal(newSVpv(pkg->info, eos-pkg->info)));
      }
    } else if (gimme == G_ARRAY) {
      char *name, *version, *release, *arch, *eos;
      get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
      if (version - name < 1 || release - version < 1 || arch - release < 1)
	  croak("invalid fullname");
      EXTEND(SP, 4);
      PUSHs(sv_2mortal(newSVpv(name, version-name-1)));
      PUSHs(sv_2mortal(newSVpv(version, release-version-1)));
      PUSHs(sv_2mortal(newSVpv(release, arch[-2] ? arch-release-1 : 0)));
      PUSHs(sv_2mortal(newSVpv(arch == eos ? "" : arch, eos-arch)));
      restore_chars();
    }
  } else if (pkg->h) {
    char *name = get_name(pkg->h, RPMTAG_NAME);
    char *version = get_name(pkg->h, RPMTAG_VERSION);
    char *release = get_name(pkg->h, RPMTAG_RELEASE);
    char *arch = headerIsEntry(pkg->h, RPMTAG_SOURCERPM) ? get_name(pkg->h, RPMTAG_ARCH) : "src";

    if (gimme == G_SCALAR) {
      const char *nvra = headerFormat(pkg->h,
	  "%{NAME}-%{VERSION}-%{RELEASE}%|DISTTAG?{-%{DISTTAG}%|DISTEPOCH?"
	  "{%{DISTEPOCH}}|}|.%|ARCH?{%|SOURCERPM?{%{ARCH}}:{src}|}:{}|",
	  NULL
	  );
      XPUSHs(sv_2mortal(newSVpvf("%s", nvra)));
      _free(nvra);
    } else if (gimme == G_ARRAY) {
      EXTEND(SP, 4);
      PUSHs(sv_2mortal(newSVpv(name, 0)));
      PUSHs(sv_2mortal(newSVpv(version, 0)));
      PUSHs(sv_2mortal(newSVpv(release, 0)));
      PUSHs(sv_2mortal(newSVpv(arch, 0)));
    }
  }
#line 2574 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_epoch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_epoch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::epoch",
			"pkg", "URPM::Package");
#line 1994 "URPM.xs"
  if (pkg->info) {
    char *s, *eos;

    if ((s = strchr(pkg->info, '@')) != NULL) {
      if ((eos = strchr(s+1, '@')) != NULL) *eos = 0; /* mark end of string to enable searching backwards */
      RETVAL = atoi(s+1);
      if (eos != NULL) *eos = '@';
    } else {
      RETVAL = 0;
    }
  } else if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_EPOCH);
  } else RETVAL = 0;
#line 2618 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_compare_pkg); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_compare_pkg)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "lpkg, rpkg");
    {
	URPM__Package	lpkg;
	URPM__Package	rpkg;
#line 2015 "URPM.xs"
  int compare = 0;
  int lepoch;
  char *lversion;
  char *lrelease;
  char *larch;
  char *leos;
  int repoch;
  char *rversion;
  char *rrelease;
  char *rarch;
  char *reos;
#line 2650 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    lpkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::compare_pkg",
			"lpkg", "URPM::Package");

	if (sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rpkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::compare_pkg",
			"rpkg", "URPM::Package");
#line 2027 "URPM.xs"
  if (lpkg == rpkg) RETVAL = 0;
  else {
    if (lpkg->info) {
      char *s;

      if ((s = strchr(lpkg->info, '@')) != NULL) {
	if ((leos = strchr(s+1, '@')) != NULL) *leos = 0; /* mark end of string to enable searching backwards */
	lepoch = atoi(s+1);
	if (leos != NULL) *leos = '@';
      } else {
	lepoch = 0;
      }
      get_fullname_parts(lpkg, NULL, &lversion, &lrelease, &larch, &leos);
      /* temporarily mark end of each substring */
      lrelease[-1] = 0;
      larch[-1] = 0;
    } else if (lpkg->h) {
      lepoch = get_int(lpkg->h, RPMTAG_EPOCH);
      lversion = get_name(lpkg->h, RPMTAG_VERSION);
      lrelease = get_name(lpkg->h, RPMTAG_RELEASE);
      larch = headerIsEntry(lpkg->h, RPMTAG_SOURCERPM) ? get_name(lpkg->h, RPMTAG_ARCH) : "src";
    } else croak("undefined package");
    if (rpkg->info) {
      char *s;

      if ((s = strchr(rpkg->info, '@')) != NULL) {
	if ((reos = strchr(s+1, '@')) != NULL) *reos = 0; /* mark end of string to enable searching backwards */
	repoch = atoi(s+1);
	if (reos != NULL) *reos = '@';
      } else {
	repoch = 0;
      }
      get_fullname_parts(rpkg, NULL, &rversion, &rrelease, &rarch, &reos);
      /* temporarily mark end of each substring */
      rrelease[-1] = 0;
      rarch[-1] = 0;
    } else if (rpkg->h) {
      repoch = get_int(rpkg->h, RPMTAG_EPOCH);
      rversion = get_name(rpkg->h, RPMTAG_VERSION);
      rrelease = get_name(rpkg->h, RPMTAG_RELEASE);
      rarch = headerIsEntry(rpkg->h, RPMTAG_SOURCERPM) ? get_name(rpkg->h, RPMTAG_ARCH) : "src";
    } else {
      /* restore info string modified */
      if (lpkg->info) {
	lrelease[-1] = '-';
	larch[-1] = '.';
      }
      restore_chars();
      croak("undefined package");
    }
    compare = lepoch - repoch;
    if (!compare) {
      compare = rpmvercmp(lversion, rversion);
      if (!compare) {
	compare = rpmvercmp(lrelease, rrelease);
	if (!compare) {
	  int lscore, rscore;
	  char *eolarch = strchr(larch, '@');
	  char *eorarch = strchr(rarch, '@');

	  read_config_files(0);
	  if (eolarch) *eolarch = 0; lscore = rpmMachineScore(RPM_MACHTABLE_INSTARCH, larch);
	  if (eorarch) *eorarch = 0; rscore = rpmMachineScore(RPM_MACHTABLE_INSTARCH, rarch);
	  if (lscore == 0) {
	    if (rscore == 0)
#if 0
              /* Nanar: TODO check this 
               * hu ?? what is the goal of strcmp, some of arch are equivalent */
              compare = 0
#endif
	      compare = strcmp(larch, rarch);
	    else
	      compare = -1;
	  } else {
	    if (rscore == 0)
	      compare = 1;
	    else
	      compare = rscore - lscore; /* score are lower for better */
	  }
	  if (eolarch) *eolarch = '@';
	  if (eorarch) *eorarch = '@';
	}
      }
    }
    /* restore info string modified */
    if (lpkg->info) {
      lrelease[-1] = '-';
      larch[-1] = '.';
    }
    if (rpkg->info) {
      rrelease[-1] = '-';
      rarch[-1] = '.';
    }
    restore_chars();
    RETVAL = compare;
  }
#line 2768 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_compare); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_compare)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, evr");
    {
	URPM__Package	pkg;
	char *	evr = (char *)SvPV_nolen(ST(1));
#line 2131 "URPM.xs"
  int compare = 0;
  int _epoch;
  char *_version;
  char *_release;
  char *_eos;
#line 2794 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::compare",
			"pkg", "URPM::Package");
#line 2137 "URPM.xs"
  if (pkg->info) {
    char *s;

    if ((s = strchr(pkg->info, '@')) != NULL) {
      if ((_eos = strchr(s+1, '@')) != NULL) *_eos = 0; /* mark end of string to enable searching backwards */
      _epoch = atoi(s+1);
      if (_eos != NULL) *_eos = '@';
    } else {
      _epoch = 0;
    }
    get_fullname_parts(pkg, NULL, &_version, &_release, &_eos, NULL);
    /* temporarily mark end of each substring */
    _release[-1] = 0;
    _eos[-1] = 0;
  } else if (pkg->h) {
    _epoch = get_int(pkg->h, RPMTAG_EPOCH);
  } else croak("undefined package");
  if (!compare) {
    char *epoch, *version, *release, *distepoch;

    /* extract epoch and version from evr */
    version = evr;
    while (*version && isdigit(*version)) version++;
    if (*version == ':') {
      epoch = evr;
      *version++ = 0;
      if (!*epoch) epoch = "0";
      compare = _epoch - (*epoch ? atoi(epoch) : 0);
      version[-1] = ':'; /* restore in memory modification */
    } else {
      /* there is no epoch defined, so assume epoch = 0 */
      version = evr;
      compare = _epoch;
    }
    if (!compare) {
      if (!pkg->info)
	_version = get_name(pkg->h, RPMTAG_VERSION);
      /* continue extracting release if any */
      if ((release = strrchr(version, '-')) != NULL) {
	*release++ = 0;
	/* XXX: compare distepoch rather than just ignoring? */
	if ((distepoch = strrchr(release, ':')) != NULL)
	  *distepoch++ = 0;

	compare = rpmvercmp(_version, version);
	if (!compare) {
	  /* need to compare with release here */
	  if (!pkg->info)
	    _release = get_name(pkg->h, RPMTAG_RELEASE);
	  compare = rpmvercmp(_release, release);
	}
	release[-1] = '-'; /* restore in memory modification */
	if (distepoch != NULL)
	  distepoch[-1] = ':';
      } else {
	compare = rpmvercmp(_version, version);
      }
    }
  }
  /* restore info string modified */
  if (pkg->info) {
    _release[-1] = '-';
    _eos[-1] = '.';
    restore_chars();
  }
  RETVAL = compare;
#line 2873 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::size",
			"pkg", "URPM::Package");
#line 2210 "URPM.xs"
  if (pkg->info) {
    char *s, *eos;

    if ((s = strchr(pkg->info, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
      if ((eos = strchr(s+1, '@')) != NULL) *eos = 0; /* mark end of string to enable searching backwards */
      RETVAL = atoi(s+1);
      if (eos != NULL) *eos = '@';
    } else {
      RETVAL = 0;
    }
  } else if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_SIZE);
  } else RETVAL = 0;
#line 2917 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_filesize); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_filesize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::filesize",
			"pkg", "URPM::Package");
#line 2230 "URPM.xs"
  if (pkg->filesize) {
    RETVAL = pkg->filesize;
  } else if (pkg->h) {
    RETVAL = sigsize_to_filesize(get_int(pkg->h, RPMTAG_SIGSIZE));
  } else RETVAL = 0;
#line 2953 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_group); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_group)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::group",
			"pkg", "URPM::Package");
#line 2242 "URPM.xs"
  if (pkg->info) {
    char *s;

    if ((s = strchr(pkg->info, '@')) != NULL && (s = strchr(s+1, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
      char *eos = strchr(s+1, '@');
      XPUSHs(sv_2mortal(newSVpv_utf8(s+1, eos != NULL ? eos-s-1 : 0)));
    }
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv_utf8(get_name(pkg->h, RPMTAG_GROUP), 0)));
  }
#line 2994 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_filename); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_filename)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::filename",
			"pkg", "URPM::Package");
#line 2257 "URPM.xs"
  if (pkg->info) {
    char *eon;

    if ((eon = strchr(pkg->info, '@')) != NULL) {
	char savbuf[4];
	memcpy(savbuf, eon, 4); /* there should be at least epoch and size described so (@0@0 minimum) */
	memcpy(eon, ".rpm", 4);
	XPUSHs(sv_2mortal(newSVpv(pkg->info, eon-pkg->info+4)));
	memcpy(eon, savbuf, 4);
    }
  } else if (pkg->h) {
    const char *nvra = headerFormat(pkg->h,
	  "%{NAME}-%{VERSION}-%{RELEASE}%|DISTTAG?{-%{DISTTAG}%|DISTEPOCH?"
	  "{%{DISTEPOCH}}|}|.%|ARCH?{%|SOURCERPM?{%{ARCH}}:{src}|}:{}|",
	  NULL
	  );

    XPUSHs(sv_2mortal(newSVpvf("%s.rpm", nvra)));
    _free(nvra);
  }
#line 3045 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_header_filename); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_header_filename)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::header_filename",
			"pkg", "URPM::Package");
#line 2283 "URPM.xs"
  if (pkg->info) {
    char *eon;

    if ((eon = strchr(pkg->info, '@')) != NULL) {
      XPUSHs(sv_2mortal(newSVpv(pkg->info, eon-pkg->info)));
    }
  } else if (pkg->h) {
    char buff[1024];
    char *p = buff;

    const char *nvra = headerFormat(pkg->h,
	  "%{NAME}-%{VERSION}-%{RELEASE}%|DISTTAG?{-%{DISTTAG}%|DISTEPOCH?"
	  "{%{DISTEPOCH}}|}|.%|ARCH?{%|SOURCERPM?{%{ARCH}}:{src}|}:{}|",
	  NULL
	  );

    p += snprintf(buff, sizeof(buff), "%s", nvra);
    XPUSHs(sv_2mortal(newSVpv(buff, p-buff)));
    _free(nvra);

  }
#line 3097 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::id",
			"pkg", "URPM::Package");
#line 2309 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX) {
    XPUSHs(sv_2mortal(newSViv(pkg->flag & FLAG_ID)));
  }
#line 3131 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_set_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, id=-1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	int	id;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_id",
			"pkg", "URPM::Package");

	if (items < 2)
	    id = -1;
	else {
	    id = (int)SvIV(ST(1));
	}
#line 2318 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX) {
    XPUSHs(sv_2mortal(newSViv(pkg->flag & FLAG_ID)));
  }
  pkg->flag &= ~FLAG_ID;
  pkg->flag |= id >= 0 && id <= FLAG_ID_MAX ? id : FLAG_ID_INVALID;
#line 3174 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_requires); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_requires)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::requires",
			"pkg", "URPM::Package");
#line 2328 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->requires, pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION,
		  callback_list_str_xpush_requires, NULL);
  SPAGAIN;
#line 3209 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_requires_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_requires_nosense)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::requires_nosense",
			"pkg", "URPM::Package");
#line 2337 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->requires, pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, 0, 
		  callback_list_str_xpush_requires, NULL);
  SPAGAIN;
#line 3244 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_suggests); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_suggests)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::suggests",
			"pkg", "URPM::Package");
#line 2346 "URPM.xs"
  PUTBACK;
  int count = return_list_str(pkg->suggests, pkg->h, RPMTAG_SUGGESTSNAME, 0, 0, callback_list_str_xpush, NULL);
  if (count == 0)
    return_list_str(pkg->suggests, pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, 0,
		    callback_list_str_xpush_old_suggests, NULL);
  SPAGAIN;
#line 3281 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::obsoletes",
			"pkg", "URPM::Package");
#line 2357 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3316 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes_nosense)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::obsoletes_nosense",
			"pkg", "URPM::Package");
#line 2366 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3350 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_obsoletes_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_obsoletes_overlap)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "pkg, s, b_nopromote=1, direction=-1");
    {
	URPM__Package	pkg;
	char *	s = (char *)SvPV_nolen(ST(1));
	int	b_nopromote;
	int	direction;
#line 2377 "URPM.xs"
  struct cb_overlap_s os;
  char *eon = NULL;
  char eonc = '\0';
#line 3376 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::obsoletes_overlap",
			"pkg", "URPM::Package");

	if (items < 3)
	    b_nopromote = 1;
	else {
	    b_nopromote = (int)SvIV(ST(2));
	}

	if (items < 4)
	    direction = -1;
	else {
	    direction = (int)SvIV(ST(3));
	}
#line 2381 "URPM.xs"
  os.name = s;
  os.flags = 0;
  while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
  if (*s) {
    eon = s;
    while (*s) {
      if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
      else if (*s == '<') os.flags |= RPMSENSE_LESS;
      else if (*s == '>') os.flags |= RPMSENSE_GREATER;
      else if (*s == '=') os.flags |= RPMSENSE_EQUAL;
      else break;
      ++s;
    }
    os.evr = s;
  } else
    os.evr = "";
  os.direction = direction;
  os.b_nopromote = b_nopromote;
  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* return_list_str returns a negative value is the callback has returned non-zero */
  RETVAL = return_list_str(pkg->obsoletes, pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION,
			   callback_list_str_overlap, &os) < 0;
  /* restore end of name */
  if (eon) *eon = eonc;
#line 3426 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_conflicts); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conflicts)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::conflicts",
			"pkg", "URPM::Package");
#line 2413 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->conflicts, pkg->h, RPMTAG_CONFLICTNAME, RPMTAG_CONFLICTFLAGS, RPMTAG_CONFLICTVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3461 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_conflicts_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conflicts_nosense)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::conflicts_nosense",
			"pkg", "URPM::Package");
#line 2422 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->conflicts, pkg->h, RPMTAG_CONFLICTNAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3495 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::provides",
			"pkg", "URPM::Package");
#line 2430 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION,
		  callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3530 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides_nosense); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides_nosense)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::provides_nosense",
			"pkg", "URPM::Package");
#line 2439 "URPM.xs"
  PUTBACK;
  return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 3564 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_provides_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_provides_overlap)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "pkg, s, b_nopromote=1, direction=1");
    {
	URPM__Package	pkg;
	char *	s = (char *)SvPV_nolen(ST(1));
	int	b_nopromote;
	int	direction;
#line 2450 "URPM.xs"
  struct cb_overlap_s os;
  char *eon = NULL;
  char eonc = '\0';
#line 3590 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::provides_overlap",
			"pkg", "URPM::Package");

	if (items < 3)
	    b_nopromote = 1;
	else {
	    b_nopromote = (int)SvIV(ST(2));
	}

	if (items < 4)
	    direction = 1;
	else {
	    direction = (int)SvIV(ST(3));
	}
#line 2454 "URPM.xs"
  os.name = s;
  os.flags = 0;
  while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
  if (*s) {
    eon = s;
    while (*s) {
      if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
      else if (*s == '<') os.flags |= RPMSENSE_LESS;
      else if (*s == '>') os.flags |= RPMSENSE_GREATER;
      else if (*s == '=') os.flags |= RPMSENSE_EQUAL;
      else break;
      ++s;
    }
    os.evr = s;
  } else
    os.evr = "";
  os.direction = direction;
  os.b_nopromote = b_nopromote;
  /* mark end of name */
  if (eon) { eonc = *eon; *eon = 0; }
  /* return_list_str returns a negative value is the callback has returned non-zero */
  RETVAL = return_list_str(pkg->provides, pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION,
			   callback_list_str_overlap, &os) < 0;
  /* restore end of name */
  if (eon) *eon = eonc;
#line 3640 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_buildarchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_buildarchs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::buildarchs",
			"pkg", "URPM::Package");
#line 2486 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_BUILDARCHS);
  SPAGAIN;
#line 3674 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_excludearchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_excludearchs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::excludearchs",
			"pkg", "URPM::Package");
#line 2494 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_EXCLUDEARCH);
  SPAGAIN;
#line 3708 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_exclusivearchs); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_exclusivearchs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::exclusivearchs",
			"pkg", "URPM::Package");
#line 2502 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_EXCLUSIVEARCH);
  SPAGAIN;
#line 3742 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_dirnames); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_dirnames)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::dirnames",
			"pkg", "URPM::Package");
#line 2510 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_DIRNAMES);
  SPAGAIN;
#line 3776 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_distepoch); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_distepoch)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::distepoch",
			"pkg", "URPM::Package");
#line 2517 "URPM.xs"
  if (pkg->info) {
    int i;
    char *tmp = pkg->info, *eos = NULL;
    for (i = 0; i < 5 && tmp != NULL; i++)
      tmp = strchr(++tmp, '@');
    if (tmp != NULL && *tmp)
      eos = strchr(++tmp, '@');
    XPUSHs(sv_2mortal(newSVpv((tmp && *tmp != '@') ? tmp : "", eos ? eos-tmp : 0)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_DISTEPOCH), 0)));
  }
#line 3818 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_disttag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_disttag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::disttag",
			"pkg", "URPM::Package");
#line 2532 "URPM.xs"
  if (pkg->info) {
    int i;
    char *tmp = pkg->info, *eos = NULL;
    for (i = 0; i < 4 && tmp != NULL; i++)
      tmp = strchr(++tmp, '@');
    if (tmp != NULL && *tmp)
      eos = strchr(++tmp, '@');
    XPUSHs(sv_2mortal(newSVpv((tmp && *tmp != '@') ? tmp : "", eos ? eos-tmp : 0)));
  } else if (pkg->h) {
    XPUSHs(sv_2mortal(newSVpv(get_name(pkg->h, RPMTAG_DISTTAG), 0)));
  }
#line 3860 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_filelinktos); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_filelinktos)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::filelinktos",
			"pkg", "URPM::Package");
#line 2548 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_FILELINKTOS);
  SPAGAIN;
#line 3894 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files",
			"pkg", "URPM::Package");
#line 2556 "URPM.xs"
  PUTBACK;
  return_files(pkg->h, 0);
  SPAGAIN;
#line 3928 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_md5sum); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_md5sum)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_md5sum",
			"pkg", "URPM::Package");
#line 2564 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_FILEMD5S);
  SPAGAIN;
#line 3962 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_owner); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_owner)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_owner",
			"pkg", "URPM::Package");
#line 2572 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_FILEUSERNAME);
  SPAGAIN;
#line 3996 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_group); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_group)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_group",
			"pkg", "URPM::Package");
#line 2580 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_FILEGROUPNAME);
  SPAGAIN;
#line 4030 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_mtime); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_mtime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_mtime",
			"pkg", "URPM::Package");
#line 2588 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILEMTIMES);
  SPAGAIN;
#line 4064 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_size",
			"pkg", "URPM::Package");
#line 2596 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILESIZES);
  SPAGAIN;
#line 4098 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_uid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_uid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_uid",
			"pkg", "URPM::Package");
#line 2604 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILEUIDS);
  SPAGAIN;
#line 4132 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_gid); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_gid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_gid",
			"pkg", "URPM::Package");
#line 2612 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILEGIDS);
  SPAGAIN;
#line 4166 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_mode); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_mode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_mode",
			"pkg", "URPM::Package");
#line 2620 "URPM.xs"
  PUTBACK;
  return_list_uint_16(pkg->h, RPMTAG_FILEMODES);
  SPAGAIN;
#line 4200 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_files_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_files_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::files_flags",
			"pkg", "URPM::Package");
#line 2628 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_FILEFLAGS);
  SPAGAIN;
#line 4234 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_conf_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_conf_files)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::conf_files",
			"pkg", "URPM::Package");
#line 2636 "URPM.xs"
  PUTBACK;
  return_files(pkg->h, FILTER_MODE_CONF_FILES);
  SPAGAIN;
#line 4268 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::changelog_time",
			"pkg", "URPM::Package");
#line 2644 "URPM.xs"
  PUTBACK;
  return_list_int32_t(pkg->h, RPMTAG_CHANGELOGTIME);
  SPAGAIN;
#line 4302 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::changelog_name",
			"pkg", "URPM::Package");
#line 2652 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_CHANGELOGNAME);
  SPAGAIN;
#line 4336 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_changelog_text); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_changelog_text)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::changelog_text",
			"pkg", "URPM::Package");
#line 2660 "URPM.xs"
  PUTBACK;
  xpush_simple_list_str(pkg->h, RPMTAG_CHANGELOGTEXT);
  SPAGAIN;
#line 4370 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_queryformat); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_queryformat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, fmt");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	char *	fmt = (char *)SvPV_nolen(ST(1));
#line 2669 "URPM.xs"
  char *s;
#line 4394 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::queryformat",
			"pkg", "URPM::Package");
#line 2671 "URPM.xs"
  if (pkg->h) {
    s = headerFormat(pkg->h, fmt, NULL);
      if (s) {
        XPUSHs(sv_2mortal(newSVpv_utf8(s,0)));
      }
  }
#line 4411 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_get_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_get_tag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, tagname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	int	tagname = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::get_tag",
			"pkg", "URPM::Package");
#line 2683 "URPM.xs"
  PUTBACK;
  return_list_tag(pkg, tagname);
  SPAGAIN;
#line 4446 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_get_tag_modifiers); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_get_tag_modifiers)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, tagname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	int	tagname = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::get_tag_modifiers",
			"pkg", "URPM::Package");
#line 2692 "URPM.xs"
  PUTBACK;
  return_list_tag_modifier(pkg->h, tagname);
  SPAGAIN;
#line 4481 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_pack_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_pack_header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::pack_header",
			"pkg", "URPM::Package");
#line 2700 "URPM.xs"
  pack_header(pkg);
#line 4511 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_update_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_update_header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "pkg, filename, ...");
    {
	URPM__Package	pkg;
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 2707 "URPM.xs"
  int packing = 0;
  int keep_all_tags = 0;
#line 4533 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::update_header",
			"pkg", "URPM::Package");
#line 2710 "URPM.xs"
  /* compability mode with older interface of parse_hdlist */
  if (items == 3) {
    packing = SvIV(ST(2));
  } else if (items > 3) {
    int i;
    for (i = 2; i < items-1; i+=2) {
      STRLEN len;
      char *s = SvPV(ST(i), len);

      if (len == 7 && !memcmp(s, "packing", 7)) {
	packing = SvTRUE(ST(i + 1));
      } else if (len == 13 && !memcmp(s, "keep_all_tags", 13)) {
	keep_all_tags = SvTRUE(ST(i+1));
      }
    }
  }
  RETVAL = update_header(filename, pkg, !packing && keep_all_tags, RPMVSF_DEFAULT);
  if (RETVAL && packing) pack_header(pkg);
#line 4564 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_free_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_free_header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::free_header",
			"pkg", "URPM::Package");
#line 2735 "URPM.xs"
  if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE)) pkg->h = headerFree(pkg->h);
  pkg->h = NULL;
#line 4595 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_build_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_build_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkg, fileno, provides_files=NULL");
    {
	URPM__Package	pkg;
	int	fileno = (int)SvIV(ST(1));
	char *	provides_files;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::build_info",
			"pkg", "URPM::Package");

	if (items < 3)
	    provides_files = NULL;
	else {
	    provides_files = (char *)SvPV_nolen(ST(2));
	}
#line 2744 "URPM.xs"
  if (pkg->info) {
    char buff[65536];
    size_t size;

    /* info line should be the last to be written */
    if (pkg->provides && *pkg->provides) {
      size = snprintf(buff, sizeof(buff), "@provides@%s\n", pkg->provides);
      if (size < sizeof(buff)) {
	if (provides_files && *provides_files) {
	  --size;
	  size += snprintf(buff+size, sizeof(buff)-size, "@%s\n", provides_files);
	}
	write_nocheck(fileno, buff, size);
      }
    }
    if (pkg->conflicts && *pkg->conflicts) {
      size = snprintf(buff, sizeof(buff), "@conflicts@%s\n", pkg->conflicts);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->obsoletes && *pkg->obsoletes) {
      size = snprintf(buff, sizeof(buff), "@obsoletes@%s\n", pkg->obsoletes);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->requires && *pkg->requires) {
      size = snprintf(buff, sizeof(buff), "@requires@%s\n", pkg->requires);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->suggests && *pkg->suggests) {
      size = snprintf(buff, sizeof(buff), "@suggests@%s\n", pkg->suggests);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->summary && *pkg->summary) {
      size = snprintf(buff, sizeof(buff), "@summary@%s\n", pkg->summary);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->filesize) {
      size = snprintf(buff, sizeof(buff), "@filesize@%d\n", pkg->filesize);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    size = snprintf(buff, sizeof(buff), "@info@%s\n", pkg->info);
    write_nocheck(fileno, buff, size);
  } else croak("no info available for package %s",
	  pkg->h ? get_name(pkg->h, RPMTAG_NAME) : "-");
#line 4674 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_build_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_build_header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, fileno");
    {
	URPM__Package	pkg;
	int	fileno = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::build_header",
			"pkg", "URPM::Package");
#line 2793 "URPM.xs"
  if (pkg->h) {
    FD_t fd;

    if ((fd = fdDup(fileno)) != NULL) {
      headerWrite(fd, pkg->h, HEADER_MAGIC_YES);
      Fclose(fd);
    } else croak("unable to get rpmio handle on fileno %d", fileno);
  } else croak("no header available for package");
#line 4711 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Package_flag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, name");
    {
	URPM__Package	pkg;
	char *	name = (char *)SvPV_nolen(ST(1));
#line 2807 "URPM.xs"
  unsigned mask;
#line 4732 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag",
			"pkg", "URPM::Package");
#line 2809 "URPM.xs"
  if (!strcmp(name, "skip")) mask = FLAG_SKIP;
  else if (!strcmp(name, "disable_obsolete")) mask = FLAG_DISABLE_OBSOLETE;
  else if (!strcmp(name, "installed")) mask = FLAG_INSTALLED;
  else if (!strcmp(name, "requested")) mask = FLAG_REQUESTED;
  else if (!strcmp(name, "required")) mask = FLAG_REQUIRED;
  else if (!strcmp(name, "upgrade")) mask = FLAG_UPGRADE;
  else croak("unknown flag: %s", name);
  RETVAL = pkg->flag & mask;
#line 4753 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkg, name, value=1");
    {
	URPM__Package	pkg;
	char *	name = (char *)SvPV_nolen(ST(1));
	int	value;
#line 2826 "URPM.xs"
  unsigned mask;
#line 4776 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag",
			"pkg", "URPM::Package");

	if (items < 3)
	    value = 1;
	else {
	    value = (int)SvIV(ST(2));
	}
#line 2828 "URPM.xs"
  if (!strcmp(name, "skip")) mask = FLAG_SKIP;
  else if (!strcmp(name, "disable_obsolete")) mask = FLAG_DISABLE_OBSOLETE;
  else if (!strcmp(name, "installed")) mask = FLAG_INSTALLED;
  else if (!strcmp(name, "requested")) mask = FLAG_REQUESTED;
  else if (!strcmp(name, "required")) mask = FLAG_REQUIRED;
  else if (!strcmp(name, "upgrade")) mask = FLAG_UPGRADE;
  else croak("unknown flag: %s", name);
  RETVAL = pkg->flag & mask;
  if (value) pkg->flag |= mask;
  else       pkg->flag &= ~mask;
#line 4805 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_skip); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_skip)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_skip",
			"pkg", "URPM::Package");
#line 2845 "URPM.xs"
  RETVAL = pkg->flag & FLAG_SKIP;
#line 4837 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_skip); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_skip)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_skip",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2854 "URPM.xs"
  RETVAL = pkg->flag & FLAG_SKIP;
  if (value) pkg->flag |= FLAG_SKIP;
  else       pkg->flag &= ~FLAG_SKIP;
#line 4878 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_base); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_base)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_base",
			"pkg", "URPM::Package");
#line 2864 "URPM.xs"
  RETVAL = pkg->flag & FLAG_BASE;
#line 4910 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_base); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_base)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_base",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2873 "URPM.xs"
  RETVAL = pkg->flag & FLAG_BASE;
  if (value) pkg->flag |= FLAG_BASE;
  else       pkg->flag &= ~FLAG_BASE;
#line 4951 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_disable_obsolete); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_disable_obsolete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_disable_obsolete",
			"pkg", "URPM::Package");
#line 2883 "URPM.xs"
  RETVAL = pkg->flag & FLAG_DISABLE_OBSOLETE;
#line 4983 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_disable_obsolete); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_disable_obsolete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_disable_obsolete",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2892 "URPM.xs"
  RETVAL = pkg->flag & FLAG_DISABLE_OBSOLETE;
  if (value) pkg->flag |= FLAG_DISABLE_OBSOLETE;
  else       pkg->flag &= ~FLAG_DISABLE_OBSOLETE;
#line 5024 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_installed); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_installed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_installed",
			"pkg", "URPM::Package");
#line 2902 "URPM.xs"
  RETVAL = pkg->flag & FLAG_INSTALLED;
#line 5056 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_installed); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_installed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_installed",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2911 "URPM.xs"
  RETVAL = pkg->flag & FLAG_INSTALLED;
  if (value) pkg->flag |= FLAG_INSTALLED;
  else       pkg->flag &= ~FLAG_INSTALLED;
#line 5097 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_requested); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_requested)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_requested",
			"pkg", "URPM::Package");
#line 2921 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUESTED;
#line 5129 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_requested); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_requested)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_requested",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2930 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUESTED;
  if (value) pkg->flag |= FLAG_REQUESTED;
  else       pkg->flag &= ~FLAG_REQUESTED;
#line 5170 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_required); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_required)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_required",
			"pkg", "URPM::Package");
#line 2940 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUIRED;
#line 5202 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_required); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_required)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_required",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2949 "URPM.xs"
  RETVAL = pkg->flag & FLAG_REQUIRED;
  if (value) pkg->flag |= FLAG_REQUIRED;
  else       pkg->flag &= ~FLAG_REQUIRED;
#line 5243 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_upgrade); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_upgrade)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_upgrade",
			"pkg", "URPM::Package");
#line 2959 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE;
#line 5275 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_flag_upgrade); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_flag_upgrade)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_flag_upgrade",
			"pkg", "URPM::Package");

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1));
	}
#line 2968 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE;
  if (value) pkg->flag |= FLAG_UPGRADE;
  else       pkg->flag &= ~FLAG_UPGRADE;
#line 5316 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_selected); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_selected)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_selected",
			"pkg", "URPM::Package");
#line 2978 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE ? pkg->flag & (FLAG_BASE | FLAG_REQUIRED) : 0;
#line 5348 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_flag_available); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_flag_available)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::flag_available",
			"pkg", "URPM::Package");
#line 2986 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_INSTALLED && !(pkg->flag & FLAG_UPGRADE)) ||
           (pkg->flag & FLAG_UPGRADE ? pkg->flag & (FLAG_BASE | FLAG_REQUIRED) : 0);
#line 5381 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_rate); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_rate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::rate",
			"pkg", "URPM::Package");
#line 2995 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_RATE) >> FLAG_RATE_POS;
#line 5413 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_set_rate); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_rate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pkg, rate");
    {
	URPM__Package	pkg;
	int	rate = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_rate",
			"pkg", "URPM::Package");
#line 3004 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_RATE) >> FLAG_RATE_POS;
  pkg->flag &= ~FLAG_RATE;
  pkg->flag |= (rate >= 0 && rate <= FLAG_RATE_MAX ? rate : FLAG_RATE_INVALID) << FLAG_RATE_POS;
#line 5448 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Package_rflags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_rflags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 3014 "URPM.xs"
  I32 gimme = GIMME_V;
#line 5471 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::rflags",
			"pkg", "URPM::Package");
#line 3016 "URPM.xs"
  if (gimme == G_ARRAY && pkg->rflags != NULL) {
    char *s = pkg->rflags;
    char *eos;
    while ((eos = strchr(s, '\t')) != NULL) {
      XPUSHs(sv_2mortal(newSVpv(s, eos-s)));
      s = eos + 1;
    }
    XPUSHs(sv_2mortal(newSVpv(s, 0)));
  }
#line 5491 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Package_set_rflags); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Package_set_rflags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "pkg, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 3030 "URPM.xs"
  I32 gimme = GIMME_V;
  char *new_rflags;
  STRLEN total_len;
  int i;
#line 5517 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Package::set_rflags",
			"pkg", "URPM::Package");
#line 3035 "URPM.xs"
  total_len = 0;
  for (i = 1; i < items; ++i)
    total_len += SvCUR(ST(i)) + 1;

  new_rflags = malloc(total_len);
  total_len = 0;
  for (i = 1; i < items; ++i) {
    STRLEN len;
    char *s = SvPV(ST(i), len);
    memcpy(new_rflags + total_len, s, len);
    new_rflags[total_len + len] = '\t';
    total_len += len + 1;
  }
  new_rflags[total_len - 1] = 0; /* but mark end-of-string correctly */

  if (gimme == G_ARRAY && pkg->rflags != NULL) {
    char *s = pkg->rflags;
    char *eos;
    while ((eos = strchr(s, '\t')) != NULL) {
      XPUSHs(sv_2mortal(newSVpv(s, eos-s)));
      s = eos + 1;
    }
    XPUSHs(sv_2mortal(newSVpv(s, 0)));
  }

  free(pkg->rflags);
  pkg->rflags = new_rflags;
#line 5555 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__DB_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "prefix=NULL, write_perm=0");
    {
	char *	prefix;
	int	write_perm;
#line 3071 "URPM.xs"
  URPM__DB db;
#line 5577 "URPM.c"
	URPM__DB	RETVAL;

	if (items < 1)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(0));
	}

	if (items < 2)
	    write_perm = 0;
	else {
	    write_perm = (int)SvIV(ST(1));
	}
#line 3073 "URPM.xs"
  read_config_files(0);
  db = malloc(sizeof(struct s_Transaction));
  db->count = 1;
  db->ts = rpmtsCreate();
  rpmtsSetRootDir(db->ts, prefix && prefix[0] ? prefix : NULL);
  if (rpmtsOpenDB(db->ts, write_perm ? O_RDWR | O_CREAT : O_RDONLY) == 0) {
    RETVAL = db;
  } else {
    RETVAL = NULL;
    (void)rpmtsFree(db->ts);
    free(db);
  }
#line 5604 "URPM.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "URPM::DB", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_rebuild); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_rebuild)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "prefix=\"\"");
    {
	char *	prefix;
#line 3092 "URPM.xs"
  rpmts ts;
#line 5626 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    prefix = "";
	else {
	    prefix = (char *)SvPV_nolen(ST(0));
	}
#line 3094 "URPM.xs"
  read_config_files(0);
  ts = rpmtsCreate();
  rpmtsSetRootDir(ts, prefix);
  RETVAL = rpmtsRebuildDB(ts) == 0;
  (void)rpmtsFree(ts);
#line 5641 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_verify); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_verify)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "prefix=\"\"");
    {
	char *	prefix;
#line 3106 "URPM.xs"
  rpmts ts;
#line 5662 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    prefix = "";
	else {
	    prefix = (char *)SvPV_nolen(ST(0));
	}
#line 3108 "URPM.xs"
  ts = rpmtsCreate();
  rpmtsSetRootDir(ts, prefix);
  RETVAL = rpmtsVerifyDB(ts) == 0;
  ts = rpmtsFree(ts);
#line 5676 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	URPM__DB	db;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"URPM::DB::DESTROY",
			"db");
#line 3119 "URPM.xs"
  (void)rpmtsFree(db->ts);
  if (!--db->count) free(db);
#line 5707 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__DB_traverse); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_traverse)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "db, callback");
    {
	URPM__DB	db;
	SV *	callback = ST(1);
#line 3127 "URPM.xs"
  Header header;
  rpmdbMatchIterator mi;
  int count = 0;
#line 5730 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::DB::traverse",
			"db", "URPM::DB");
#line 3131 "URPM.xs"
  db->ts = rpmtsLink(db->ts, "URPM::DB::traverse");
  ts_nosignature(db->ts);
  mi = rpmtsInitIterator(db->ts, RPMDBI_PACKAGES, NULL, 0);
  while ((header = rpmdbNextIterator(mi))) {
    if (SvROK(callback)) {
      dSP;
      URPM__Package pkg = calloc(1, sizeof(struct s_Package));

      pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
      pkg->h = header;

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
      PUTBACK;

      call_sv(callback, G_DISCARD | G_SCALAR);

      SPAGAIN;
      pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
    }
    ++count;
  }
  rpmdbFreeIterator(mi);
  (void)rpmtsFree(db->ts);
  RETVAL = count;
#line 5768 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_traverse_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_traverse_tag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "db, tag, names, callback");
    {
	URPM__DB	db;
	char *	tag = (char *)SvPV_nolen(ST(1));
	SV *	names = ST(2);
	SV *	callback = ST(3);
#line 3166 "URPM.xs"
  Header header;
  rpmdbMatchIterator mi;
  int count = 0;
#line 5794 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::DB::traverse_tag",
			"db", "URPM::DB");
#line 3170 "URPM.xs"
  if (SvROK(names) && SvTYPE(SvRV(names)) == SVt_PVAV) {
    AV* names_av = (AV*)SvRV(names);
    int len = av_len(names_av);
    int i, rpmtag;

    rpmtag = rpmtag_from_string(tag);

    for (i = 0; i <= len; ++i) {
      STRLEN str_len;
      SV **isv = av_fetch(names_av, i, 0);
      char *name = SvPV(*isv, str_len);
      db->ts = rpmtsLink(db->ts, "URPM::DB::traverse_tag");
      ts_nosignature(db->ts);
      mi = rpmtsInitIterator(db->ts, rpmtag, name, str_len);
      while ((header = rpmdbNextIterator(mi))) {
	if (SvROK(callback)) {
	  dSP;
	  URPM__Package pkg = calloc(1, sizeof(struct s_Package));

	  pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
	  pkg->h = header;

	  PUSHMARK(SP);
	  XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
	  PUTBACK;

	  call_sv(callback, G_DISCARD | G_SCALAR);

	  SPAGAIN;
	  pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
	}
	++count;
      }
      (void)rpmdbFreeIterator(mi);
      (void)rpmtsFree(db->ts);
    } 
  } else croak("bad arguments list");
  RETVAL = count;
#line 5845 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_traverse_tag_find); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_traverse_tag_find)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "db, tag, name, callback");
    {
	URPM__DB	db;
	char *	tag = (char *)SvPV_nolen(ST(1));
	char *	name = (char *)SvPV_nolen(ST(2));
	SV *	callback = ST(3);
#line 3218 "URPM.xs"
  Header header;
  rpmdbMatchIterator mi;
#line 5870 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::DB::traverse_tag_find",
			"db", "URPM::DB");
#line 3221 "URPM.xs"
  int rpmtag = rpmtag_from_string(tag);
  int found = 0;

  db->ts = rpmtsLink(db->ts, "URPM::DB::traverse_tag");
  ts_nosignature(db->ts);
  mi = rpmtsInitIterator(db->ts, rpmtag, name, 0);
  while ((header = rpmdbNextIterator(mi))) {
      dSP;
      URPM__Package pkg = calloc(1, sizeof(struct s_Package));

      pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
      pkg->h = header;

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
      PUTBACK;

      int count = call_sv(callback, G_SCALAR);

      SPAGAIN;
      pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */

      if (count == 1 && POPi) {
	found = 1;
	break;
      }
  }
  (void)rpmdbFreeIterator(mi);
  (void)rpmtsFree(db->ts);
  RETVAL = found;
#line 5913 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__DB_create_transaction); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__DB_create_transaction)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, prefix=\"/\"");
    {
	URPM__DB	db;
	char *	prefix;
	URPM__Transaction	RETVAL;

	if (sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::DB::create_transaction",
			"db", "URPM::DB");

	if (items < 2)
	    prefix = "/";
	else {
	    prefix = (char *)SvPV_nolen(ST(1));
	}
#line 3259 "URPM.xs"
  /* this is *REALLY* dangerous to create a new transaction while another is open,
     so use the db transaction instead. */
  db->ts = rpmtsLink(db->ts, "URPM::DB::create_transaction");
  ++db->count;
  RETVAL = db;
#line 5955 "URPM.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "URPM::Transaction", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "trans");
    {
	URPM__Transaction	trans;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not a reference",
			"URPM::Transaction::DESTROY",
			"trans");
#line 3274 "URPM.xs"
  (void)rpmtsFree(trans->ts);
  if (!--trans->count) free(trans);
#line 5987 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Transaction_set_script_fd); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_set_script_fd)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, fdno");
    {
	URPM__Transaction	trans;
	int	fdno = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::set_script_fd",
			"trans", "URPM::Transaction");
#line 3282 "URPM.xs"
  rpmtsSetScriptFd(trans->ts, fdDup(fdno));
#line 6017 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM__Transaction_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "trans, pkg, ...");
    {
	URPM__Transaction	trans;
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::add",
			"trans", "URPM::Transaction");

	if (sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::add",
			"pkg", "URPM::Package");
#line 3289 "URPM.xs"
  if ((pkg->flag & FLAG_ID) <= FLAG_ID_MAX && pkg->h != NULL) {
    int update = 0;
#ifndef RPM_ORG
    rpmRelocation  relocations = NULL;
#else
    rpmRelocation *relocations = NULL;
#endif
    /* compability mode with older interface of add */
    if (items == 3) {
      update = SvIV(ST(2));
    } else if (items > 3) {
      int i;
      for (i = 2; i < items-1; i+=2) {
	STRLEN len;
	char *s = SvPV(ST(i), len);

	if (len == 6 && !memcmp(s, "update", 6)) {
	  update = SvIV(ST(i+1));
	} else if (len == 11 && !memcmp(s, "excludepath", 11)) {
	  if (SvROK(ST(i+1)) && SvTYPE(SvRV(ST(i+1))) == SVt_PVAV) {
	    AV *excludepath = (AV*)SvRV(ST(i+1));
	    I32 j = 1 + av_len(excludepath);
#ifndef RPM_ORG
	    int relno = 0;
	    relocations = malloc(sizeof(rpmRelocation));
#else
	    relocations = calloc(j + 1, sizeof(rpmRelocation));
#endif
	    while (--j >= 0) {
	      SV **e = av_fetch(excludepath, j, 0);
	      if (e != NULL && *e != NULL) {
#ifndef RPM_ORG
		rpmfiAddRelocation(&relocations, &relno, SvPV_nolen(*e), NULL);
#else
		relocations[j].oldPath = SvPV_nolen(*e);
#endif
	      }
	    }
	  }
	}
      }
    }

    if(headerIsEntry(pkg->h, RPMTAG_DISTEPOCH)) {
      pretend_distepoch(pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION);
    }
    remap_suggests(pkg->h);
    /* If we're going to update to rpm 5.3, we'll create an empty DB_CONFIG
     * first iff there's no existing DB_CONFIG in place. This will prevent
     * switching to possibly incompatible configurations during upgrade.
     */
    if (!strcmp(get_name(pkg->h, RPMTAG_NAME), "rpm")) {
      const char *version = get_name(pkg->h, RPMTAG_VERSION);
      if (rpmvercmp(version, "5.3") >= 0) {
	char *fn = rpmGetPath(rpmtsRootDir(trans->ts), "%{_dbpath}", "/DB_CONFIG", NULL);
	struct stat st;
	if (stat(fn, &st)) {
	  FD_t fd = Fopen(fn, "w");
	  Fclose(fd);
	}
	fn = _free(fn);
      }
    }

    RETVAL = rpmtsAddInstallElement(trans->ts, pkg->h, (fnpyKey)(1+(long)(pkg->flag & FLAG_ID)), update, relocations) == 0;

    rpmte te = rpmtsElement(trans->ts, 0);
    headerLink(pkg->h);
    rpmteSetHeader(te, pkg->h);
    headerUnlink(pkg->h);

    /* free allocated memory, check rpm is copying it just above, at least in 4.0.4 */
#ifndef RPM_ORG
    rpmfiFreeRelocations(relocations);
#else
    free(relocations);
#endif
  } else RETVAL = 0;
#line 6135 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_remove)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, name");
    {
	URPM__Transaction	trans;
	char *	name = (char *)SvPV_nolen(ST(1));
#line 3375 "URPM.xs"
  Header h;
  rpmdbMatchIterator mi;
  int count = 0;
  char *boa = NULL, *bor = NULL;
#line 6160 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::remove",
			"trans", "URPM::Transaction");
#line 3380 "URPM.xs"
  /* hide arch in name if present */
  if ((boa = strrchr(name, '.'))) {
    *boa = 0;
    if ((bor = strrchr(name, '-'))) {
      *bor = 0;
      if (!strrchr(name, '-')) {
	*boa = '.'; boa = NULL;
      }
      *bor = '-'; bor = NULL;
    } else {
      *boa = '.'; boa = NULL;
    }
  }
  mi = rpmtsInitIterator(trans->ts, RPMDBI_LABEL, name, 0);
  while ((h = rpmdbNextIterator(mi))) {
    unsigned int recOffset = rpmdbGetIteratorOffset(mi);
    if (recOffset != 0) {
      rpmtsAddEraseElement(trans->ts, h, recOffset);
      ++count;
    }
  }
  rpmdbFreeIterator(mi);
  if (boa) *boa = '.';
  RETVAL=count;
#line 6197 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_traverse); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_traverse)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, callback");
    {
	URPM__Transaction	trans;
	SV *	callback = ST(1);
#line 3412 "URPM.xs"
  rpmdbMatchIterator mi;
  Header h;
  int c = 0;
#line 6221 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::traverse",
			"trans", "URPM::Transaction");
#line 3416 "URPM.xs"
  mi = rpmtsInitIterator(trans->ts, RPMDBI_PACKAGES, NULL, 0);
  while ((h = rpmdbNextIterator(mi))) {
    if (SvROK(callback)) {
      dSP;
      URPM__Package pkg = calloc(1, sizeof(struct s_Package));
      pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
      pkg->h = h;
      PUSHMARK(SP);
      XPUSHs(sv_2mortal(sv_setref_pv(newSVpv("", 0), "URPM::Package", pkg)));
      PUTBACK;
      call_sv(callback, G_DISCARD | G_SCALAR);
      SPAGAIN;
      pkg->h = 0; /* avoid using it anymore, in case it has been copied inside callback */
    }
    ++c;
  }
  rpmdbFreeIterator(mi);
  RETVAL = c;
#line 6252 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_check); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_check)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "trans, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
#line 3441 "URPM.xs"
  I32 gimme = GIMME_V;
  int translate_message = 0;
  int i;
#line 6277 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::check",
			"trans", "URPM::Transaction");
#line 3445 "URPM.xs"
  for (i = 1; i < items-1; i+=2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 17 && !memcmp(s, "translate_message", 17)) {
      translate_message = SvIV(ST(i+1));
    }
  }
  if (rpmtsCheck(trans->ts)) {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(0)));
    } else if (gimme == G_ARRAY) {
      XPUSHs(sv_2mortal(newSVpv("error while checking dependencies", 0)));
    }
  } else {
    rpmps ps = rpmtsProblems(trans->ts);
    if (rpmpsNumProblems(ps) > 0) {
      if (gimme == G_SCALAR) {
	XPUSHs(sv_2mortal(newSViv(0)));
      } else if (gimme == G_ARRAY) {
	/* now translation is handled by rpmlib, but only for version 4.2 and above */
	PUTBACK;
	return_problems(ps, 1, 0);
	SPAGAIN;
      }
    } else if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(1)));
    }
    ps = rpmpsFree(ps);
  }
#line 6318 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Transaction_order); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_order)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "trans");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
#line 3480 "URPM.xs"
  I32 gimme = GIMME_V;
#line 6341 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::order",
			"trans", "URPM::Transaction");
#line 3482 "URPM.xs"
  if (rpmtsOrder(trans->ts) == 0) {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(1)));
    }
  } else {
    if (gimme == G_SCALAR) {
      XPUSHs(sv_2mortal(newSViv(0)));
    } else if (gimme == G_ARRAY) {
      XPUSHs(sv_2mortal(newSVpv("error while ordering dependencies", 0)));
    }
  }
#line 6363 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM__Transaction_NElements); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_NElements)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "trans");
    {
	URPM__Transaction	trans;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::NElements",
			"trans", "URPM::Transaction");
#line 3498 "URPM.xs"
  RETVAL = rpmtsNElements(trans->ts);
#line 6395 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_name",
			"trans", "URPM::Transaction");
#line 3507 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteN(te) : NULL;
#line 6429 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_version",
			"trans", "URPM::Transaction");
#line 3517 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteV(te) : NULL;
#line 6463 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_release); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_release)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_release",
			"trans", "URPM::Transaction");
#line 3527 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteR(te) : NULL;
#line 6497 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_Element_fullname); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_Element_fullname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1));
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::Element_fullname",
			"trans", "URPM::Transaction");
#line 3537 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  RETVAL = te ? (char *) rpmteNEVRA(te) : NULL;
#line 6531 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM__Transaction_run); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM__Transaction_run)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "trans, data, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
	SV *	data = ST(1);
#line 3547 "URPM.xs"
  struct s_TransactionData td = { NULL, NULL, NULL, NULL, NULL, 100000, data };
  rpmtransFlags transFlags = RPMTRANS_FLAG_NONE;
  int probFilter = 0;
  int translate_message = 0, raw_message = 0;
  int i;
#line 6559 "URPM.c"

	if (sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::Transaction::run",
			"trans", "URPM::Transaction");
#line 3553 "URPM.xs"
  for (i = 2 ; i < items - 1 ; i += 2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 4 && !memcmp(s, "test", 4)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_TEST;
    } else if (len == 11 && !memcmp(s, "excludedocs", 11)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_NODOCS;
    } else if (len == 5) {
      if (!memcmp(s, "force", 5)) {
	if (SvIV(ST(i+1))) probFilter |= (RPMPROB_FILTER_REPLACEPKG |
					  RPMPROB_FILTER_REPLACEOLDFILES |
					  RPMPROB_FILTER_REPLACENEWFILES |
					  RPMPROB_FILTER_OLDPACKAGE);
      } else if (!memcmp(s, "delta", 5))
	td.min_delta = SvIV(ST(i+1));
    } else if (len == 6 && !memcmp(s, "nosize", 6)) {
      if (SvIV(ST(i+1))) probFilter |= (RPMPROB_FILTER_DISKSPACE|RPMPROB_FILTER_DISKNODES);
    } else if (len == 9 && !memcmp(s, "noscripts", 9)) {
      if (SvIV(ST(i+1))) transFlags |= (RPMTRANS_FLAG_NOSCRIPTS |
				        RPMTRANS_FLAG_NOPRE |
				        RPMTRANS_FLAG_NOPREUN |
				        RPMTRANS_FLAG_NOPOST |
				        RPMTRANS_FLAG_NOPOSTUN );
    } else if (len == 10 && !memcmp(s, "oldpackage", 10)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_OLDPACKAGE;
    } else if (len == 11 && !memcmp(s, "replacepkgs", 11)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_REPLACEPKG;
    } else if (len == 11 && !memcmp(s, "raw_message", 11)) {
      raw_message = 1;
    } else if (len == 12 && !memcmp(s, "replacefiles", 12)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_REPLACEOLDFILES | RPMPROB_FILTER_REPLACENEWFILES;
    } else if (len == 9 && !memcmp(s, "repackage", 9)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_REPACKAGE;
    } else if (len == 6 && !memcmp(s, "justdb", 6)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_JUSTDB;
    } else if (len == 10 && !memcmp(s, "ignorearch", 10)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_IGNOREARCH;
    } else if (len == 17 && !memcmp(s, "translate_message", 17))
      translate_message = 1;
    else if (len >= 9 && !memcmp(s, "callback_", 9)) {
      if (len == 9+4 && !memcmp(s+9, "open", 4)) {
	if (SvROK(ST(i+1))) td.callback_open = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "close", 5)) {
	if (SvROK(ST(i+1))) td.callback_close = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "trans", 5)) {
	if (SvROK(ST(i+1))) td.callback_trans = ST(i+1);
      } else if (len == 9+6 && !memcmp(s+9, "uninst", 6)) {
	if (SvROK(ST(i+1))) td.callback_uninst = ST(i+1);
      } else if (len == 9+4 && !memcmp(s+9, "inst", 4)) {
	if (SvROK(ST(i+1))) td.callback_inst = ST(i+1);
      }
    }
  }
  /* check macros */
  {
    char *repa = rpmExpand("%_repackage_all_erasures", NULL);
    if (repa && *repa && *repa != '0')
      transFlags |= RPMTRANS_FLAG_REPACKAGE;
    if (repa) free(repa);
  }
  rpmtsSetFlags(trans->ts, transFlags);
  trans->ts = rpmtsLink(trans->ts, "URPM::Transaction::run");
  rpmtsSetNotifyCallback(trans->ts, rpmRunTransactions_callback, &td);
  if (rpmtsRun(trans->ts, NULL, probFilter) > 0) {
    rpmps ps = rpmtsProblems(trans->ts);
    PUTBACK;
    return_problems(ps, translate_message, raw_message || !translate_message);
    SPAGAIN;
    ps = rpmpsFree(ps);
  }
  rpmtsEmpty(trans->ts);
  (void)rpmtsFree(trans->ts);
#line 6643 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_bind_rpm_textdomain_codeset); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_bind_rpm_textdomain_codeset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 3635 "URPM.xs"
  rpm_codeset_is_utf8 = 1;
  bind_textdomain_codeset("rpm", "UTF-8");
#line 6664 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_read_config_files); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_read_config_files)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 3641 "URPM.xs"
  RETVAL = (read_config_files(1) == 0); /* force re-read of configuration files */
#line 6685 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_list_rpm_tag); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_list_rpm_tag)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "urpm=Nullsv");
    {
	SV *	urpm;

	if (items < 1)
	    urpm = Nullsv;
	else {
	    urpm = ST(0);
	}
#line 3649 "URPM.xs"
   croak("list_rpm_tag() has been removed from perl-URPM. please report if you need it back");
#line 6712 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_rpmvercmp); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmvercmp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "one, two");
    {
	char *	one = (char *)SvPV_nolen(ST(0));
	char *	two = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	RETVAL = rpmvercmp(one, two);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_ranges_overlap); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_ranges_overlap)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "a, b, b_nopromote=1");
    {
	char *	a = (char *)SvPV_nolen(ST(0));
	char *	b = (char *)SvPV_nolen(ST(1));
	int	b_nopromote;
#line 3662 "URPM.xs"
  char *sa = a, *sb = b;
  int aflags = 0, bflags = 0;
#line 6758 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 3)
	    b_nopromote = 1;
	else {
	    b_nopromote = (int)SvIV(ST(2));
	}
#line 3665 "URPM.xs"
  while (*sa && *sa != ' ' && *sa != '[' && *sa != '<' && *sa != '>' && *sa != '=' && *sa == *sb) {
    ++sa;
    ++sb;
  }
  if ((*sa && *sa != ' ' && *sa != '[' && *sa != '<' && *sa != '>' && *sa != '=') ||
      (*sb && *sb != ' ' && *sb != '[' && *sb != '<' && *sb != '>' && *sb != '=')) {
    /* the strings are sure to be different */
    RETVAL = 0;
  } else {
    while (*sa) {
      if (*sa == ' ' || *sa == '[' || *sa == '*' || *sa == ']');
      else if (*sa == '<') aflags |= RPMSENSE_LESS;
      else if (*sa == '>') aflags |= RPMSENSE_GREATER;
      else if (*sa == '=') aflags |= RPMSENSE_EQUAL;
      else break;
      ++sa;
    }
    while (*sb) {
      if (*sb == ' ' || *sb == '[' || *sb == '*' || *sb == ']');
      else if (*sb == '<') bflags |= RPMSENSE_LESS;
      else if (*sb == '>') bflags |= RPMSENSE_GREATER;
      else if (*sb == '=') bflags |= RPMSENSE_EQUAL;
      else break;
      ++sb;
    }
    RETVAL = ranges_overlap(aflags, sa, bflags, sb, b_nopromote);
  }
#line 6795 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_parse_synthesis__XS); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_synthesis__XS)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3700 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 9, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      char buff[65536];
      char *p, *eol;
      int buff_len;
      struct s_Package pkg;
      gzFile f;
      int start_id = 1 + av_len(depslist);
      SV *callback = NULL;

      if (items > 2) {
	int i;
	for (i = 2; i < items-1; i+=2) {
	  STRLEN len;
	  char *s = SvPV(ST(i), len);

	  if (len == 8 && !memcmp(s, "callback", 8)) {
	    if (SvROK(ST(i+1))) callback = ST(i+1);
	  }
	}
      }

      PUTBACK;
      if ((f = gzopen(filename, "rb")) != NULL) {
	memset(&pkg, 0, sizeof(struct s_Package));
	buff[sizeof(buff)-1] = 0;
	p = buff;
	int ok = 1;
	while ((buff_len = gzread(f, p, sizeof(buff)-1-(p-buff))) >= 0 &&
	       (buff_len += p-buff)) {
	  buff[buff_len] = 0;
	  p = buff;
	  if ((eol = strchr(p, '\n')) != NULL) {
	    do {
	      *eol++ = 0;
	      if (!parse_line(depslist, provides, obsoletes, &pkg, p, urpm, callback)) { ok = 0; break; }
	      p = eol;
	    } while ((eol = strchr(p, '\n')) != NULL);
	  } else {
	    /* a line larger than sizeof(buff) has been encountered, bad file problably */
	    fprintf(stderr, "invalid line <%s>\n", p);
	    ok = 0;
	    break;
	  }
	  if (gzeof(f)) {
	    if (!parse_line(depslist, provides, obsoletes, &pkg, p, urpm, callback)) ok = 0;
	    break;
	  } else {
	    /* move the remaining non-complete-line at beginning */
	    memmove(buff, p, buff_len-(p-buff));
	    /* point to the end of the non-complete-line */
	    p = &buff[buff_len-(p-buff)];
	  }
	}
	if (gzclose(f) != 0) ok = 0;
	SPAGAIN;
	if (ok) {
	  XPUSHs(sv_2mortal(newSViv(start_id)));
	  XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	}
      } else {
	  SV **nofatal = hv_fetch((HV*)SvRV(urpm), "nofatal", 7, 0);
	  if (!errno) errno = EINVAL; /* zlib error */
	  if (!nofatal || !SvIV(*nofatal))
	      croak(errno == ENOENT
		      ? "unable to read synthesis file %s"
		      : "unable to uncompress synthesis file %s", filename);
      }
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 6895 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_parse_hdlist__XS); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_hdlist__XS)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3783 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 9, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      pid_t pid = 0;
      int d;
      int empty_archive = 0;
      FD_t fd;

      d = open_archive(filename, &pid, &empty_archive);
      fd = fdDup(d);
      close(d);

      if (empty_archive) {
	  XPUSHs(sv_2mortal(newSViv(1 + av_len(depslist))));
	  XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
      } else if (d >= 0 && fd) {
	Header header;
	int start_id = 1 + av_len(depslist);
	int packing = 0;
	SV *callback = NULL;

	/* compability mode with older interface of parse_hdlist */
	if (items == 3) {
	  packing = SvTRUE(ST(2));
	} else if (items > 3) {
	  int i;
	  for (i = 2; i < items-1; i+=2) {
	    STRLEN len;
	    char *s = SvPV(ST(i), len);

	    if (len == 7 && !memcmp(s, "packing", 7)) {
	      packing = SvTRUE(ST(i+1));
	    } else if (len == 8 && !memcmp(s, "callback", 8)) {
	      if (SvROK(ST(i+1))) callback = ST(i+1);
	    }
	  }
	}

	PUTBACK;
	do {
	  header=headerRead(fd, HEADER_MAGIC_YES);
	  if (header != NULL) {
	    struct s_Package pkg, *_pkg;
	    SV *sv_pkg;

	    convert_header(header);

	    memset(&pkg, 0, sizeof(struct s_Package));
	    pkg.flag = 1 + av_len(depslist);
	    pkg.h = header;
	    sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package",
				  _pkg = memcpy(malloc(sizeof(struct s_Package)), &pkg, sizeof(struct s_Package)));
	    if (call_package_callback(urpm, sv_pkg, callback)) {
	      if (provides) {
		update_provides(_pkg, provides);
		update_provides_files(_pkg, provides);
	      }
	      if (obsoletes) update_obsoletes(_pkg, obsoletes);
	      if (packing) pack_header(_pkg);
	      av_push(depslist, sv_pkg);
	    }
	  }
	} while (header != NULL);

	int ok = Fclose(fd) == 0;

	if (pid) {
	  kill(pid, SIGTERM);
	  int status;
	  int rc = waitpid(pid, &status, 0);
	  ok = rc != -1 && WEXITSTATUS(status) != 1; /* in our standard case, gzip will exit with status code 2, meaning "decompression OK, trailing garbage ignored" */
	  pid = 0;
	} else if (!empty_archive) {
	  ok = av_len(depslist) >= start_id;
	}
	SPAGAIN;
	if (ok) {
	  XPUSHs(sv_2mortal(newSViv(start_id)));
	  XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	}
      } else {
	  SV **nofatal = hv_fetch((HV*)SvRV(urpm), "nofatal", 7, 0);
	  if (!nofatal || !SvIV(*nofatal))
	      croak("cannot open hdlist file %s", filename);
      }
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 7011 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_parse_rpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_parse_rpm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0);
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 3882 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 8, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      struct s_Package pkg, *_pkg;
      SV *sv_pkg;
      int packing = 0;
      int keep_all_tags = 0;
      SV *callback = NULL;
      rpmVSFlags vsflags = RPMVSF_DEFAULT;

      /* compability mode with older interface of parse_hdlist */
      if (items == 3) {
	packing = SvTRUE(ST(2));
      } else if (items > 3) {
	int i;
	for (i = 2; i < items-1; i+=2) {
	  STRLEN len;
	  char *s = SvPV(ST(i), len);

	  if (len == 7 && !memcmp(s, "packing", 7)) {
	    packing = SvTRUE(ST(i + 1));
	  } else if (len == 13 && !memcmp(s, "keep_all_tags", 13)) {
	    keep_all_tags = SvTRUE(ST(i+1));
	  } else if (len == 8 && !memcmp(s, "callback", 8)) {
	    if (SvROK(ST(i+1))) callback = ST(i+1);
	  } else if (len == 5) {
            if (!memcmp(s, "nopgp", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOSHA1 | RPMVSF_NOSHA1HEADER);
            }
            else if (!memcmp(s, "nogpg", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOSHA1 | RPMVSF_NOSHA1HEADER);
            }
            else if (!memcmp(s, "nomd5", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NOMD5 |  RPMVSF_NOMD5HEADER);
            }
            else if (!memcmp(s, "norsa", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NORSA | RPMVSF_NORSAHEADER);
            }
            else if (!memcmp(s, "nodsa", 5)) {
              if (SvIV(ST(i+1))) vsflags |= (RPMVSF_NODSA | RPMVSF_NODSAHEADER);
            }
          } else if (len == 9) {
            if (!memcmp(s, "nodigests", 9)) {
              if (SvIV(ST(i+1))) vsflags |= _RPMVSF_NODIGESTS;
            } else
            if (!memcmp(s, "nopayload", 9)) {
              if (SvIV(ST(i+1))) vsflags |= _RPMVSF_NOPAYLOAD;
            }
          } 
	}
      }
      PUTBACK;
      memset(&pkg, 0, sizeof(struct s_Package));
      pkg.flag = 1 + av_len(depslist);
      _pkg = memcpy(malloc(sizeof(struct s_Package)), &pkg, sizeof(struct s_Package));

      if (update_header(filename, _pkg, keep_all_tags, vsflags)) {
	sv_pkg = sv_setref_pv(newSVpv("", 0), "URPM::Package", _pkg);
	if (call_package_callback(urpm, sv_pkg, callback)) {
	  if (provides) {
	    update_provides(_pkg, provides);
	    update_provides_files(_pkg, provides);
	  }
	  if (obsoletes) update_obsoletes(_pkg, obsoletes);
	  if (packing) pack_header(_pkg);
	  av_push(depslist, sv_pkg);
	}
	SPAGAIN;
	/* only one element read */
	XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
	XPUSHs(sv_2mortal(newSViv(av_len(depslist))));
      } else free(_pkg);
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 7114 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_verify_rpm); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_verify_rpm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "filename, ...");
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 3967 "URPM.xs"
  FD_t fd;
  int i, oldlogmask;
  rpmts ts = NULL;
  struct rpmQVKArguments_s qva;
#line 7138 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3972 "URPM.xs"
  /* Don't display error messages */
  oldlogmask = rpmlogSetMask(RPMLOG_UPTO(RPMLOG_PRI(4)));
  memset(&qva, 0, sizeof(struct rpmQVKArguments_s));
  qva.qva_source = RPMQV_RPM;
  qva.qva_flags = VERIFY_ALL;
  for (i = 1 ; i < items - 1 ; i += 2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);
    if (len == 9 && !strncmp(s, "nodigests", 9)) {
      if (SvIV(ST(i+1))) qva.qva_flags &= ~VERIFY_DIGEST;
    } else if (len == 12 && !strncmp(s, "nosignatures", 12)) {
      if (SvIV(ST(i+1))) qva.qva_flags &= ~VERIFY_SIGNATURE;
    }
  }
  fd = Fopen(filename, "r");
  if (fd == NULL) {
    RETVAL = 0;
  } else {
    read_config_files(0);
    ts = rpmtsCreate();
    rpmtsSetRootDir(ts, "/");
    rpmtsOpenDB(ts, O_RDONLY);
    if (rpmVerifySignatures(&qva, ts, fd, filename)) {
      RETVAL = 0;
    } else {
      RETVAL = 1;
    }
    Fclose(fd);
    (void)rpmtsFree(ts);
  }
  rpmlogSetMask(oldlogmask);

#line 7174 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_get_gpg_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_get_gpg_fingerprint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 4012 "URPM.xs"
    uint8_t fingerprint[sizeof(pgpKeyID_t)];
    char fingerprint_str[sizeof(pgpKeyID_t) * 2 + 1];
    const uint8_t *pkt = NULL;
    size_t pktlen = 0;
    int rc;

#line 7200 "URPM.c"
	char *	RETVAL;
	dXSTARG;
#line 4019 "URPM.xs"
    memset (fingerprint, 0, sizeof (fingerprint));
    if ((rc = pgpReadPkts(filename, (uint8_t ** ) &pkt, &pktlen)) <= 0) {
	pktlen = 0;
    } else if (rc != PGPARMOR_PUBKEY) {
	pktlen = 0;
    } else {
	unsigned int i;
        pgpPubkeyFingerprint (pkt, pktlen, fingerprint);
   	for (i = 0; i < sizeof (pgpKeyID_t); i++) {
	    sprintf(&fingerprint_str[i*2], "%02x", fingerprint[i]);
	}
    }
    _free(pkt);
    RETVAL = fingerprint_str;
#line 7218 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM_verify_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_verify_signature)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "filename, prefix=\"/\"");
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
	char *	prefix;
#line 4042 "URPM.xs"
  rpmts ts = NULL;
  char result[1024];
  rpmRC rc;
  FD_t fd;
  Header h;
#line 7244 "URPM.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    prefix = "/";
	else {
	    prefix = (char *)SvPV_nolen(ST(1));
	}
#line 4048 "URPM.xs"
  fd = Fopen(filename, "r");
  if (fd == NULL) {
    RETVAL = "NOT OK (could not read file)";
  } else {
    read_config_files(0);
    ts = rpmtsCreate();
    rpmtsSetRootDir(ts, prefix);
    rpmtsOpenDB(ts, O_RDONLY);
    rpmtsSetVSFlags(ts, RPMVSF_DEFAULT);
    rc = rpmReadPackageFile(ts, fd, filename, &h);
    Fclose(fd);
    *result = '\0';
    switch(rc) {
      case RPMRC_OK:
	if (h) {
	  char *fmtsig = headerFormat(
	      h,
	      "%|DSAHEADER?{%{DSAHEADER:pgpsig}}:{%|RSAHEADER?{%{RSAHEADER:pgpsig}}:"
	      "{%|SIGGPG?{%{SIGGPG:pgpsig}}:{%|SIGPGP?{%{SIGPGP:pgpsig}}:{(none)}|}|}|}|",
	      NULL);
	  snprintf(result, sizeof(result), "OK (%s)", fmtsig);
	  free(fmtsig);
	} else snprintf(result, sizeof(result), "NOT OK (bad rpm): %s", rpmlogMessage());
	break;
      case RPMRC_NOTFOUND:
	snprintf(result, sizeof(result), "NOT OK (signature not found): %s", rpmlogMessage());
	break;
      case RPMRC_FAIL:
	snprintf(result, sizeof(result), "NOT OK (fail): %s", rpmlogMessage());
	break;
      case RPMRC_NOTTRUSTED:
	snprintf(result, sizeof(result), "NOT OK (key not trusted): %s", rpmlogMessage());
	break;
      case RPMRC_NOKEY:
	snprintf(result, sizeof(result), "NOT OK (no key): %s", rpmlogMessage());
	break;
    }
    RETVAL = result;
    if (h) h = headerFree(h);
    (void)rpmtsFree(ts);
  }

#line 7296 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM_import_pubkey_file); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_import_pubkey_file)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "db, filename");
    {
	URPM__DB	db;
	char *	filename = (char *)SvPV_nolen(ST(1));
#line 4099 "URPM.xs"
    const uint8_t *pkt = NULL;
    size_t pktlen = 0;
    int rc;
#line 7320 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"URPM::import_pubkey_file",
			"db", "URPM::DB");
#line 4104 "URPM.xs"
    rpmts ts = rpmtsLink(db->ts, "URPM::import_pubkey_file");
    rpmtsClean(ts);

    if ((rc = pgpReadPkts(filename, (uint8_t ** ) &pkt, &pktlen)) <= 0) {
        RETVAL = 0;
    } else if (rc != PGPARMOR_PUBKEY) {
        RETVAL = 0;
    } else if (rpmtsImportPubkey(ts, pkt, pktlen) != RPMRC_OK) {
        RETVAL = 0;
    } else {
        RETVAL = 1;
    }
    pkt = _free(pkt);
    (void)rpmtsFree(ts);
#line 7347 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_import_pubkey); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_import_pubkey)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 4124 "URPM.xs"
  unused_variable(&items);
  croak("import_pubkey() is dead. use import_pubkey_file() instead");
  RETVAL = 1;
#line 7370 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_archscore); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_archscore)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "arch");
    {
	const char *	arch = (const char *)SvPV_nolen(ST(0));
#line 4134 "URPM.xs"
#ifndef RPM_ORG
  char * platform = NULL;
#endif
#line 7393 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 4138 "URPM.xs"
  read_config_files(0);
#ifndef RPM_ORG
  platform = rpmExpand(arch, "-%{_target_vendor}-%{_target_os}%{?_gnu}", NULL);
  RETVAL=rpmPlatformScore(platform, NULL, 0);
  _free(platform);
#else
  RETVAL=rpmMachineScore(RPM_MACHTABLE_INSTARCH, arch);
#endif
#line 7405 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_osscore); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_osscore)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "os");
    {
	const char *	os = (const char *)SvPV_nolen(ST(0));
#line 4153 "URPM.xs"
#ifndef RPM_ORG
  char * platform = NULL;
#endif
#line 7428 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 4157 "URPM.xs"
  read_config_files(0);
#ifndef RPM_ORG
  platform = rpmExpand("%{_target_cpu}-%{_target_vendor}-", os, "%{?_gnu}", NULL);
  RETVAL=rpmPlatformScore(platform, NULL, 0);
  _free(platform);
#else
  RETVAL=rpmMachineScore(RPM_MACHTABLE_INSTOS, os);
#endif
#line 7440 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_platformscore); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_platformscore)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "platform");
    {
	const char *	platform = (const char *)SvPV_nolen(ST(0));
	int	RETVAL;
	dXSTARG;
#line 4172 "URPM.xs"
  read_config_files(0);
#ifndef RPM_ORG
  RETVAL=rpmPlatformScore(platform, NULL, 0);
#else
  unused_variable(platform);
  croak("platformscore() is available only since rpm 4.4.8");
  RETVAL=0;
#endif
#line 7470 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_URPM_stream2header); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_stream2header)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	FILE *	fp = PerlIO_findFILE(IoIFP(sv_2io(ST(0))));
#line 4187 "URPM.xs"
    FD_t fd;
    URPM__Package pkg;
#line 7494 "URPM.c"
#line 4190 "URPM.xs"
    if ((fd = fdDup(fileno(fp)))) {
	pkg = (URPM__Package)malloc(sizeof(struct s_Package));
	memset(pkg, 0, sizeof(struct s_Package));
        pkg->h = headerRead(fd, HEADER_MAGIC_YES);
        if (pkg->h) {
            SV *sv_pkg;

	    convert_header(pkg->h);

            EXTEND(SP, 1);
            sv_pkg = sv_newmortal();
            sv_setref_pv(sv_pkg, "URPM::Package", (void*)pkg);
            PUSHs(sv_pkg);
        }
        Fclose(fd);
    }
#line 7512 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_spec2srcheader); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_spec2srcheader)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "specfile");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	specfile = (char *)SvPV_nolen(ST(0));
#line 4211 "URPM.xs"
    rpmts ts = rpmtsCreate();
    URPM__Package pkg;
    Spec spec = NULL;
#line 7537 "URPM.c"
#line 4215 "URPM.xs"
/* ensure the config is in memory with all macro */
  read_config_files(0);
/* Do not verify architecture */
#define SPEC_ANYARCH 1
/* Do not verify whether sources exist */
#define SPEC_FORCE 1
  if (!parseSpec(ts, specfile, "/", NULL, 0, NULL, NULL, SPEC_ANYARCH, SPEC_FORCE)) {
    SV *sv_pkg;
    spec = rpmtsSetSpec(ts, NULL);
#ifdef RPM_ORG
    if (! spec->sourceHeader)
#endif
      initSourceHeader(spec);
    pkg = (URPM__Package)malloc(sizeof(struct s_Package));
    memset(pkg, 0, sizeof(struct s_Package));
    headerPutString(spec->sourceHeader, RPMTAG_SOURCERPM, "");

    {
      struct rpmtd_s td = {
	.tag = RPMTAG_ARCH,
	.type = RPM_STRING_TYPE,
	.data = (void *) "src",
	.count = 1,
      };
      /* parseSpec() sets RPMTAG_ARCH to %{_target_cpu} whereas we really a header similar to .src.rpm header */
      headerMod(spec->sourceHeader, &td);
    }

    pkg->h = headerLink(spec->sourceHeader);
    sv_pkg = sv_newmortal();
    sv_setref_pv(sv_pkg, "URPM::Package", (void*)pkg);
    XPUSHs(sv_pkg);
    spec = freeSpec(spec);
  } else {
    XPUSHs(&PL_sv_undef);
    /* apparently rpmlib sets errno this when given a bad spec. */
    if (errno == EBADF)
      errno = 0;
  }
  ts = rpmtsFree(ts);
#line 7579 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_expand); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_expand)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	name = (char *)SvPV_nolen(ST(0));
#line 4260 "URPM.xs"
    const char * value = rpmExpand(name, NULL);
    XPUSHs(sv_2mortal(newSVpv(value, 0)));
#line 7603 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_add_macro_noexpand); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_add_macro_noexpand)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "macro");
    {
	char *	macro = (char *)SvPV_nolen(ST(0));
#line 4267 "URPM.xs"
    rpmDefineMacro(NULL, macro, RMIL_DEFAULT);
#line 7624 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_del_macro); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_del_macro)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
#line 4273 "URPM.xs"
    delMacro(NULL, name);
#line 7644 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_URPM_loadmacrosfile); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_loadmacrosfile)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	filename = (char *)SvPV_nolen(ST(0));
#line 4279 "URPM.xs"
    rpmInitMacros(NULL, filename);
#line 7666 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_resetmacros); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_resetmacros)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4284 "URPM.xs"
    rpmFreeMacros(NULL);
#line 7688 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_setVerbosity); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_setVerbosity)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "level");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	level = (int)SvIV(ST(0));
#line 4290 "URPM.xs"
    rpmSetVerbosity(level);
#line 7711 "URPM.c"
	PUTBACK;
	return;
    }
}


XS(XS_URPM_rpmErrorString); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmErrorString)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;
#line 4295 "URPM.xs"
  RETVAL = rpmlogMessage();
#line 7733 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_URPM_rpmErrorWriteTo); /* prototype to pass -Wmissing-prototypes */
XS(XS_URPM_rpmErrorWriteTo)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0));
#line 4303 "URPM.xs"
  rpmError_callback_data = fd;
  rpmlogSetCallback(rpmError_callback, NULL);

  /* vim:set ts=8 sts=2 sw=2: */
#line 7757 "URPM.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_URPM); /* prototype to pass -Wmissing-prototypes */
XS(boot_URPM)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    const char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("URPM::Package::DESTROY", XS_URPM__Package_DESTROY, file);
        newXS("URPM::Package::name", XS_URPM__Package_name, file);
        newXS("URPM::Package::version", XS_URPM__Package_version, file);
        newXS("URPM::Package::release", XS_URPM__Package_release, file);
        newXS("URPM::Package::arch", XS_URPM__Package_arch, file);
        newXS("URPM::Package::is_arch_compat__XS", XS_URPM__Package_is_arch_compat__XS, file);
        newXS("URPM::Package::is_platform_compat", XS_URPM__Package_is_platform_compat, file);
        newXS("URPM::Package::summary", XS_URPM__Package_summary, file);
        newXS("URPM::Package::description", XS_URPM__Package_description, file);
        newXS("URPM::Package::sourcerpm", XS_URPM__Package_sourcerpm, file);
        newXS("URPM::Package::packager", XS_URPM__Package_packager, file);
        newXS("URPM::Package::buildhost", XS_URPM__Package_buildhost, file);
        newXS("URPM::Package::buildtime", XS_URPM__Package_buildtime, file);
        newXS("URPM::Package::installtid", XS_URPM__Package_installtid, file);
        newXS("URPM::Package::url", XS_URPM__Package_url, file);
        newXS("URPM::Package::license", XS_URPM__Package_license, file);
        newXS("URPM::Package::distribution", XS_URPM__Package_distribution, file);
        newXS("URPM::Package::vendor", XS_URPM__Package_vendor, file);
        newXS("URPM::Package::os", XS_URPM__Package_os, file);
        newXS("URPM::Package::payload_format", XS_URPM__Package_payload_format, file);
        newXS("URPM::Package::fullname", XS_URPM__Package_fullname, file);
        newXS("URPM::Package::epoch", XS_URPM__Package_epoch, file);
        newXS("URPM::Package::compare_pkg", XS_URPM__Package_compare_pkg, file);
        newXS("URPM::Package::compare", XS_URPM__Package_compare, file);
        newXS("URPM::Package::size", XS_URPM__Package_size, file);
        newXS("URPM::Package::filesize", XS_URPM__Package_filesize, file);
        newXS("URPM::Package::group", XS_URPM__Package_group, file);
        newXS("URPM::Package::filename", XS_URPM__Package_filename, file);
        newXS("URPM::Package::header_filename", XS_URPM__Package_header_filename, file);
        newXS("URPM::Package::id", XS_URPM__Package_id, file);
        newXS("URPM::Package::set_id", XS_URPM__Package_set_id, file);
        newXS("URPM::Package::requires", XS_URPM__Package_requires, file);
        newXS("URPM::Package::requires_nosense", XS_URPM__Package_requires_nosense, file);
        newXS("URPM::Package::suggests", XS_URPM__Package_suggests, file);
        newXS("URPM::Package::obsoletes", XS_URPM__Package_obsoletes, file);
        newXS("URPM::Package::obsoletes_nosense", XS_URPM__Package_obsoletes_nosense, file);
        newXS("URPM::Package::obsoletes_overlap", XS_URPM__Package_obsoletes_overlap, file);
        newXS("URPM::Package::conflicts", XS_URPM__Package_conflicts, file);
        newXS("URPM::Package::conflicts_nosense", XS_URPM__Package_conflicts_nosense, file);
        newXS("URPM::Package::provides", XS_URPM__Package_provides, file);
        newXS("URPM::Package::provides_nosense", XS_URPM__Package_provides_nosense, file);
        newXS("URPM::Package::provides_overlap", XS_URPM__Package_provides_overlap, file);
        newXS("URPM::Package::buildarchs", XS_URPM__Package_buildarchs, file);
        newXS("URPM::Package::excludearchs", XS_URPM__Package_excludearchs, file);
        newXS("URPM::Package::exclusivearchs", XS_URPM__Package_exclusivearchs, file);
        newXS("URPM::Package::dirnames", XS_URPM__Package_dirnames, file);
        newXS("URPM::Package::distepoch", XS_URPM__Package_distepoch, file);
        newXS("URPM::Package::disttag", XS_URPM__Package_disttag, file);
        newXS("URPM::Package::filelinktos", XS_URPM__Package_filelinktos, file);
        newXS("URPM::Package::files", XS_URPM__Package_files, file);
        newXS("URPM::Package::files_md5sum", XS_URPM__Package_files_md5sum, file);
        newXS("URPM::Package::files_owner", XS_URPM__Package_files_owner, file);
        newXS("URPM::Package::files_group", XS_URPM__Package_files_group, file);
        newXS("URPM::Package::files_mtime", XS_URPM__Package_files_mtime, file);
        newXS("URPM::Package::files_size", XS_URPM__Package_files_size, file);
        newXS("URPM::Package::files_uid", XS_URPM__Package_files_uid, file);
        newXS("URPM::Package::files_gid", XS_URPM__Package_files_gid, file);
        newXS("URPM::Package::files_mode", XS_URPM__Package_files_mode, file);
        newXS("URPM::Package::files_flags", XS_URPM__Package_files_flags, file);
        newXS("URPM::Package::conf_files", XS_URPM__Package_conf_files, file);
        newXS("URPM::Package::changelog_time", XS_URPM__Package_changelog_time, file);
        newXS("URPM::Package::changelog_name", XS_URPM__Package_changelog_name, file);
        newXS("URPM::Package::changelog_text", XS_URPM__Package_changelog_text, file);
        newXS("URPM::Package::queryformat", XS_URPM__Package_queryformat, file);
        newXS("URPM::Package::get_tag", XS_URPM__Package_get_tag, file);
        newXS("URPM::Package::get_tag_modifiers", XS_URPM__Package_get_tag_modifiers, file);
        newXS("URPM::Package::pack_header", XS_URPM__Package_pack_header, file);
        newXS("URPM::Package::update_header", XS_URPM__Package_update_header, file);
        newXS("URPM::Package::free_header", XS_URPM__Package_free_header, file);
        newXS("URPM::Package::build_info", XS_URPM__Package_build_info, file);
        newXS("URPM::Package::build_header", XS_URPM__Package_build_header, file);
        newXS("URPM::Package::flag", XS_URPM__Package_flag, file);
        newXS("URPM::Package::set_flag", XS_URPM__Package_set_flag, file);
        newXS("URPM::Package::flag_skip", XS_URPM__Package_flag_skip, file);
        newXS("URPM::Package::set_flag_skip", XS_URPM__Package_set_flag_skip, file);
        newXS("URPM::Package::flag_base", XS_URPM__Package_flag_base, file);
        newXS("URPM::Package::set_flag_base", XS_URPM__Package_set_flag_base, file);
        newXS("URPM::Package::flag_disable_obsolete", XS_URPM__Package_flag_disable_obsolete, file);
        newXS("URPM::Package::set_flag_disable_obsolete", XS_URPM__Package_set_flag_disable_obsolete, file);
        newXS("URPM::Package::flag_installed", XS_URPM__Package_flag_installed, file);
        newXS("URPM::Package::set_flag_installed", XS_URPM__Package_set_flag_installed, file);
        newXS("URPM::Package::flag_requested", XS_URPM__Package_flag_requested, file);
        newXS("URPM::Package::set_flag_requested", XS_URPM__Package_set_flag_requested, file);
        newXS("URPM::Package::flag_required", XS_URPM__Package_flag_required, file);
        newXS("URPM::Package::set_flag_required", XS_URPM__Package_set_flag_required, file);
        newXS("URPM::Package::flag_upgrade", XS_URPM__Package_flag_upgrade, file);
        newXS("URPM::Package::set_flag_upgrade", XS_URPM__Package_set_flag_upgrade, file);
        newXS("URPM::Package::flag_selected", XS_URPM__Package_flag_selected, file);
        newXS("URPM::Package::flag_available", XS_URPM__Package_flag_available, file);
        newXS("URPM::Package::rate", XS_URPM__Package_rate, file);
        newXS("URPM::Package::set_rate", XS_URPM__Package_set_rate, file);
        newXS("URPM::Package::rflags", XS_URPM__Package_rflags, file);
        newXS("URPM::Package::set_rflags", XS_URPM__Package_set_rflags, file);
        newXS("URPM::DB::open", XS_URPM__DB_open, file);
        newXS("URPM::DB::rebuild", XS_URPM__DB_rebuild, file);
        newXS("URPM::DB::verify", XS_URPM__DB_verify, file);
        newXS("URPM::DB::DESTROY", XS_URPM__DB_DESTROY, file);
        newXS("URPM::DB::traverse", XS_URPM__DB_traverse, file);
        newXS("URPM::DB::traverse_tag", XS_URPM__DB_traverse_tag, file);
        newXS("URPM::DB::traverse_tag_find", XS_URPM__DB_traverse_tag_find, file);
        newXS("URPM::DB::create_transaction", XS_URPM__DB_create_transaction, file);
        newXS("URPM::Transaction::DESTROY", XS_URPM__Transaction_DESTROY, file);
        newXS("URPM::Transaction::set_script_fd", XS_URPM__Transaction_set_script_fd, file);
        newXS("URPM::Transaction::add", XS_URPM__Transaction_add, file);
        newXS("URPM::Transaction::remove", XS_URPM__Transaction_remove, file);
        newXS("URPM::Transaction::traverse", XS_URPM__Transaction_traverse, file);
        newXS("URPM::Transaction::check", XS_URPM__Transaction_check, file);
        newXS("URPM::Transaction::order", XS_URPM__Transaction_order, file);
        newXS("URPM::Transaction::NElements", XS_URPM__Transaction_NElements, file);
        newXS("URPM::Transaction::Element_name", XS_URPM__Transaction_Element_name, file);
        newXS("URPM::Transaction::Element_version", XS_URPM__Transaction_Element_version, file);
        newXS("URPM::Transaction::Element_release", XS_URPM__Transaction_Element_release, file);
        newXS("URPM::Transaction::Element_fullname", XS_URPM__Transaction_Element_fullname, file);
        newXS("URPM::Transaction::run", XS_URPM__Transaction_run, file);
        newXS("URPM::bind_rpm_textdomain_codeset", XS_URPM_bind_rpm_textdomain_codeset, file);
        newXS("URPM::read_config_files", XS_URPM_read_config_files, file);
        newXS("URPM::list_rpm_tag", XS_URPM_list_rpm_tag, file);
        newXS("URPM::rpmvercmp", XS_URPM_rpmvercmp, file);
        newXS("URPM::ranges_overlap", XS_URPM_ranges_overlap, file);
        newXS("URPM::parse_synthesis__XS", XS_URPM_parse_synthesis__XS, file);
        newXS("URPM::parse_hdlist__XS", XS_URPM_parse_hdlist__XS, file);
        newXS("URPM::parse_rpm", XS_URPM_parse_rpm, file);
        newXS("URPM::verify_rpm", XS_URPM_verify_rpm, file);
        newXS("URPM::get_gpg_fingerprint", XS_URPM_get_gpg_fingerprint, file);
        newXS("URPM::verify_signature", XS_URPM_verify_signature, file);
        newXS("URPM::import_pubkey_file", XS_URPM_import_pubkey_file, file);
        newXS("URPM::import_pubkey", XS_URPM_import_pubkey, file);
        newXS("URPM::archscore", XS_URPM_archscore, file);
        newXS("URPM::osscore", XS_URPM_osscore, file);
        newXS("URPM::platformscore", XS_URPM_platformscore, file);
        newXS("URPM::stream2header", XS_URPM_stream2header, file);
        newXS("URPM::spec2srcheader", XS_URPM_spec2srcheader, file);
        newXS("URPM::expand", XS_URPM_expand, file);
        newXS("URPM::add_macro_noexpand", XS_URPM_add_macro_noexpand, file);
        newXS("URPM::del_macro", XS_URPM_del_macro, file);
        newXS("URPM::loadmacrosfile", XS_URPM_loadmacrosfile, file);
        newXS("URPM::resetmacros", XS_URPM_resetmacros, file);
        newXS("URPM::setVerbosity", XS_URPM_setVerbosity, file);
        newXS("URPM::rpmErrorString", XS_URPM_rpmErrorString, file);
        newXS("URPM::rpmErrorWriteTo", XS_URPM_rpmErrorWriteTo, file);

    /* Initialisation Section */

#line 3630 "URPM.xs"
(void) read_config_files(0);

#line 7925 "URPM.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

